# Code generated by smithy-python-codegen DO NOT EDIT.

import json
from typing import Any

from smithy_core.documents import Document, DocumentValue
from smithy_core.utils import (
    epoch_seconds_to_datetime,
    expect_type,
    limited_parse_float,
)
from smithy_http.aio.interfaces import HTTPResponse
from smithy_http.aio.restjson import parse_rest_json_error_info

from .config import Config
from .errors import (
    ApiError,
    NoSuchResource,
    NotAllowed,
    ServiceError,
    Unauthorized,
    UnexpectedServerError,
    UnknownApiError,
    ValidationException,
)
from .models import (
    AccountListMember,
    AccountPermissions,
    AddDiscoveredRecipientAsRecipientsOutput,
    ArchiveDiscoveredRecipientOutput,
    AssetListRecord,
    AssetRecord,
    CalendarSpec,
    CategoryListMember,
    ClassificationStatsData,
    ComplianceDetail,
    ComplianceRisk,
    ConnectorListMember,
    CreateAssetOutput,
    CreateCategoryOutput,
    CreateDepartmentOutput,
    CreateDomainOutput,
    CreateDpiaOutput,
    CreateEmployeeOutput,
    CreateHeadquarterOutput,
    CreateProcessingActivityOutput,
    CreateRecipientOutput,
    CreateScanOutput,
    CreateThresholdOutput,
    DataSecurityEvent,
    DataType,
    DepartmentForFilterMember,
    DepartmentListMember,
    DepartmentObject,
    DescribeAccountOutput,
    DescribeAssetOutput,
    DescribeCatalogResourceOutput,
    DescribeCategoryOutput,
    DescribeCloudAccountOutput,
    DescribeConnectorOutput,
    DescribeDepartmentOutput,
    DescribeDiscoveredRecipientOutput,
    DescribeDomainOutput,
    DescribeDpiaOutput,
    DescribeEmployeeOutput,
    DescribeHeadquarterOutput,
    DescribeInspectionResultOutput,
    DescribeInventoryResourceOutput,
    DescribeIssueOutput,
    DescribeProcessingActivityOutput,
    DescribeRecipientOutput,
    DescribeScanOutput,
    DescribeThresholdOutput,
    DescribeTomOutput,
    DescribeUserProfileOutput,
    DiscoveredRecipientListMember,
    DomainListMember,
    DpiaAvailabilityRisk,
    DpiaAvailabilityRiskImpact,
    DpiaAvailabilityRiskThreat,
    DpiaConfidentialityRisk,
    DpiaConfidentialityRiskImpact,
    DpiaConfidentialityRiskThreat,
    DpiaIntegrityRisk,
    DpiaIntegrityRiskImpact,
    DpiaIntegrityRiskThreat,
    DpiaPrivacyFramework,
    DpiaRiskRiskSource,
    EmployeeForFilterMember,
    EmployeeListMember,
    Events,
    ExportedDataUrl,
    HeadquarterListRecord,
    HeadquarterRecord,
    InfoTypesCombinationFilter,
    InfotypeSnapshot,
    InspectionPolicy,
    InspectionResultRecord,
    IssueNotification,
    IssueRecord,
    IssueResourceDetails,
    LawfulBasis,
    LeafResourcesDataRecordMember,
    ListAccountsOutput,
    ListAssetsOutput,
    ListCatalogLeafResourcesExportOutput,
    ListCatalogLeafResourcesOutput,
    ListConnectorsOutput,
    ListDepartmentsForFilterOutput,
    ListDepartmentsOutput,
    ListDiscoveredRecipientsOutput,
    ListDiscoveredRecipientsUsersOutput,
    ListDomainsOutput,
    ListEmployeesForFilterOutput,
    ListEmployeesOutput,
    ListEventsOutput,
    ListHeadquartersOutput,
    ListInfotypeCategoriesOutput,
    ListInsightsFilterOutput,
    ListInsightsFilterValueParameter,
    ListInspectionResultsOutput,
    ListInventoryResourcesExportOutput,
    ListInventoryResourcesOutput,
    ListIssuesOutput,
    ListLogsOutput,
    ListProcessingActivitiesExportOutput,
    ListProcessingActivitiesOfRecipientOutput,
    ListProcessingActivitiesOutput,
    ListProcessingActivityFilterMember,
    ListProcessingActivityFilterOutput,
    ListRecipientFilterOutput,
    ListRecipientsExportOutput,
    ListRecipientsForFilterOutput,
    ListRecipientsOutput,
    ListScansOutput,
    ListTomsOutput,
    ListUserProfilesOutput,
    LogMember,
    ManagementMethod,
    ManagerObject,
    OktaUserDiscoveryListMember,
    OwnerObject,
    PageInsightsExportOutput,
    PauseScanOutput,
    PollDomainOutput,
    PostalAddress,
    PrepareDetailedInspectionResultOutput,
    ProcessingActivityDepartment,
    ProcessingActivityEmployee,
    ProcessingActivityListRecord,
    ProcessingActivityOfRecipientMember,
    ProcessingActivityRecipientMember,
    RecipientFilterOutputListMember,
    RecipientForFilterMember,
    RecipientListMember,
    RemoveAssetOutput,
    RemoveCategoryOutput,
    RemoveDepartmentOutput,
    RemoveDomainOutput,
    RemoveDpiaOutput,
    RemoveEmployeeOutput,
    RemoveHeadquarterOutput,
    RemoveProcessingActivityOutput,
    RemoveRecipientOutput,
    RemoveThresholdOutput,
    ResourceInventoryListMember,
    ResourceStatsData,
    ResumeScanOutput,
    RetentionPeriod,
    SampleTokens,
    ScanDataProcessed,
    ScanFilter,
    ScanInformation,
    ScanLimits,
    ScanMeta,
    ScanParameters,
    ScanRecord,
    ScanResources,
    ScanSchedule,
    ScanStats,
    SecurityRisk,
    StateChangeEvents,
    StopScanOutput,
    SummarizeClassificationStatsOutput,
    SummarizeResourceStatsOutput,
    TagFilter,
    TaggingResult,
    TomListMember,
    UntagResourcesOutput,
    UpdateAssetOutput,
    UpdateCategoryOutput,
    UpdateDepartmentOutput,
    UpdateDomainOutput,
    UpdateDpiaOutput,
    UpdateEmployeeOutput,
    UpdateHeadquarterOutput,
    UpdateProcessingActivityOutput,
    UpdateRecipientOutput,
    UpdateThresholdOutput,
    UpdateTomOutput,
    UserProfileRecord,
    ValidationExceptionField,
)


async def _deserialize_add_discovered_recipient_as_recipients(
    http_response: HTTPResponse, config: Config
) -> AddDiscoveredRecipientAsRecipientsOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_add_discovered_recipient_as_recipients(
            http_response, config
        )

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_recipient_ids := output.get("recipientIds")) is not None:
        kwargs["recipient_ids"] = _deserialize_uuid_collection(_recipient_ids, config)

    return AddDiscoveredRecipientAsRecipientsOutput(**kwargs)


async def _deserialize_error_add_discovered_recipient_as_recipients(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_archive_discovered_recipient(
    http_response: HTTPResponse, config: Config
) -> ArchiveDiscoveredRecipientOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_archive_discovered_recipient(
            http_response, config
        )

    kwargs: dict[str, Any] = {}

    return ArchiveDiscoveredRecipientOutput(**kwargs)


async def _deserialize_error_archive_discovered_recipient(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_create_asset(
    http_response: HTTPResponse, config: Config
) -> CreateAssetOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_create_asset(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "assetId" not in output:
        raise ServiceError(
            'Expected to find "assetId" in the operation output, but it was not present.'
        )
    kwargs["asset_id"] = expect_type(str, output["assetId"])

    return CreateAssetOutput(**kwargs)


async def _deserialize_error_create_asset(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_create_category(
    http_response: HTTPResponse, config: Config
) -> CreateCategoryOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_create_category(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "categoryLabel" not in output:
        raise ServiceError(
            'Expected to find "categoryLabel" in the operation output, but it was not present.'
        )
    kwargs["category_label"] = expect_type(str, output["categoryLabel"])

    return CreateCategoryOutput(**kwargs)


async def _deserialize_error_create_category(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_create_department(
    http_response: HTTPResponse, config: Config
) -> CreateDepartmentOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_create_department(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "departmentId" not in output:
        raise ServiceError(
            'Expected to find "departmentId" in the operation output, but it was not present.'
        )
    kwargs["department_id"] = expect_type(str, output["departmentId"])

    return CreateDepartmentOutput(**kwargs)


async def _deserialize_error_create_department(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_create_domain(
    http_response: HTTPResponse, config: Config
) -> CreateDomainOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_create_domain(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "domainId" not in output:
        raise ServiceError(
            'Expected to find "domainId" in the operation output, but it was not present.'
        )
    kwargs["domain_id"] = expect_type(str, output["domainId"])

    return CreateDomainOutput(**kwargs)


async def _deserialize_error_create_domain(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_create_dpia(
    http_response: HTTPResponse, config: Config
) -> CreateDpiaOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_create_dpia(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "dpiaId" not in output:
        raise ServiceError(
            'Expected to find "dpiaId" in the operation output, but it was not present.'
        )
    kwargs["dpia_id"] = expect_type(str, output["dpiaId"])

    return CreateDpiaOutput(**kwargs)


async def _deserialize_error_create_dpia(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_create_employee(
    http_response: HTTPResponse, config: Config
) -> CreateEmployeeOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_create_employee(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "employeeId" not in output:
        raise ServiceError(
            'Expected to find "employeeId" in the operation output, but it was not present.'
        )
    kwargs["employee_id"] = expect_type(str, output["employeeId"])

    return CreateEmployeeOutput(**kwargs)


async def _deserialize_error_create_employee(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_create_headquarter(
    http_response: HTTPResponse, config: Config
) -> CreateHeadquarterOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_create_headquarter(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "headquarterId" not in output:
        raise ServiceError(
            'Expected to find "headquarterId" in the operation output, but it was not present.'
        )
    kwargs["headquarter_id"] = expect_type(str, output["headquarterId"])

    return CreateHeadquarterOutput(**kwargs)


async def _deserialize_error_create_headquarter(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_create_processing_activity(
    http_response: HTTPResponse, config: Config
) -> CreateProcessingActivityOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_create_processing_activity(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "processingActivityId" not in output:
        raise ServiceError(
            'Expected to find "processingActivityId" in the operation output, but it was not present.'
        )
    kwargs["processing_activity_id"] = expect_type(str, output["processingActivityId"])

    return CreateProcessingActivityOutput(**kwargs)


async def _deserialize_error_create_processing_activity(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_create_recipient(
    http_response: HTTPResponse, config: Config
) -> CreateRecipientOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_create_recipient(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "recipientId" not in output:
        raise ServiceError(
            'Expected to find "recipientId" in the operation output, but it was not present.'
        )
    kwargs["recipient_id"] = expect_type(str, output["recipientId"])

    return CreateRecipientOutput(**kwargs)


async def _deserialize_error_create_recipient(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_create_scan(
    http_response: HTTPResponse, config: Config
) -> CreateScanOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_create_scan(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "scanId" not in output:
        raise ServiceError(
            'Expected to find "scanId" in the operation output, but it was not present.'
        )
    kwargs["scan_id"] = expect_type(str, output["scanId"])

    return CreateScanOutput(**kwargs)


async def _deserialize_error_create_scan(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_create_threshold(
    http_response: HTTPResponse, config: Config
) -> CreateThresholdOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_create_threshold(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "thresholdId" not in output:
        raise ServiceError(
            'Expected to find "thresholdId" in the operation output, but it was not present.'
        )
    kwargs["threshold_id"] = expect_type(str, output["thresholdId"])

    return CreateThresholdOutput(**kwargs)


async def _deserialize_error_create_threshold(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_describe_account(
    http_response: HTTPResponse, config: Config
) -> DescribeAccountOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_describe_account(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_deleted_at := output.get("deletedAt")) is not None:
        kwargs["deleted_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _deleted_at)
        )

    if (_data_plane_ids := output.get("dataPlaneIds")) is not None:
        kwargs["data_plane_ids"] = _deserialize_data_plane_ids(_data_plane_ids, config)

    if (_permissions := output.get("permissions")) is not None:
        kwargs["permissions"] = _deserialize_account_permissions(_permissions, config)

    if (_meta := output.get("meta")) is not None:
        kwargs["meta"] = _deserialize_open_properties(_meta, config)

    if (_cloud_account_id := output.get("cloudAccountId")) is not None:
        kwargs["cloud_account_id"] = expect_type(str, _cloud_account_id)

    if (_created_at := output.get("createdAt")) is not None:
        kwargs["created_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _created_at)
        )

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_updated_at := output.get("updatedAt")) is not None:
        kwargs["updated_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _updated_at)
        )

    if (_type := output.get("type")) is not None:
        kwargs["type"] = expect_type(str, _type)

    if "accountId" not in output:
        raise ServiceError(
            'Expected to find "accountId" in the operation output, but it was not present.'
        )
    kwargs["account_id"] = expect_type(str, output["accountId"])

    return DescribeAccountOutput(**kwargs)


async def _deserialize_error_describe_account(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_describe_asset(
    http_response: HTTPResponse, config: Config
) -> DescribeAssetOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_describe_asset(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_type := output.get("type")) is not None:
        kwargs["type"] = expect_type(str, _type)

    if "assetId" not in output:
        raise ServiceError(
            'Expected to find "assetId" in the operation output, but it was not present.'
        )
    kwargs["asset_id"] = expect_type(str, output["assetId"])

    if (_location_type := output.get("locationType")) is not None:
        kwargs["location_type"] = expect_type(str, _location_type)

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_location_id := output.get("locationId")) is not None:
        kwargs["location_id"] = expect_type(str, _location_id)

    if (_toms := output.get("toms")) is not None:
        kwargs["toms"] = _deserialize_tom_collection(_toms, config)

    if (_tom_ids := output.get("tomIds")) is not None:
        kwargs["tom_ids"] = _deserialize_uuid_collection(_tom_ids, config)

    if (_location := output.get("location")) is not None:
        kwargs["location"] = _deserialize_headquarter_record(_location, config)

    return DescribeAssetOutput(**kwargs)


async def _deserialize_error_describe_asset(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_describe_catalog_resource(
    http_response: HTTPResponse, config: Config
) -> DescribeCatalogResourceOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_describe_catalog_resource(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_compliance := output.get("compliance")) is not None:
        kwargs["compliance"] = _deserialize_compliance_detail_list(_compliance, config)

    if (_owner := output.get("owner")) is not None:
        kwargs["owner"] = _deserialize_owner_object_list(_owner, config)

    if (_snapshot := output.get("snapshot")) is not None:
        kwargs["snapshot"] = _deserialize_inspection_result_snapshot(_snapshot, config)

    if (_parent_id := output.get("parentId")) is not None:
        kwargs["parent_id"] = expect_type(str, _parent_id)

    if "resourceId" not in output:
        raise ServiceError(
            'Expected to find "resourceId" in the operation output, but it was not present.'
        )
    kwargs["resource_id"] = expect_type(str, output["resourceId"])

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_type := output.get("type")) is not None:
        kwargs["type"] = expect_type(str, _type)

    if (_meta := output.get("meta")) is not None:
        kwargs["meta"] = _deserialize_open_properties(_meta, config)

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_last_scanned := output.get("lastScanned")) is not None:
        kwargs["last_scanned"] = epoch_seconds_to_datetime(
            expect_type(int | float, _last_scanned)
        )

    if (_sample_tokens := output.get("sampleTokens")) is not None:
        kwargs["sample_tokens"] = _deserialize_tokens(_sample_tokens, config)

    if (_source := output.get("source")) is not None:
        kwargs["source"] = expect_type(str, _source)

    return DescribeCatalogResourceOutput(**kwargs)


async def _deserialize_error_describe_catalog_resource(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_describe_category(
    http_response: HTTPResponse, config: Config
) -> DescribeCategoryOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_describe_category(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "categoryLabel" not in output:
        raise ServiceError(
            'Expected to find "categoryLabel" in the operation output, but it was not present.'
        )
    kwargs["category_label"] = expect_type(str, output["categoryLabel"])

    if "description" not in output:
        raise ServiceError(
            'Expected to find "description" in the operation output, but it was not present.'
        )
    kwargs["description"] = expect_type(str, output["description"])

    if (_updated_at := output.get("updatedAt")) is not None:
        kwargs["updated_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _updated_at)
        )

    if (_created_at := output.get("createdAt")) is not None:
        kwargs["created_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _created_at)
        )

    return DescribeCategoryOutput(**kwargs)


async def _deserialize_error_describe_category(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_describe_cloud_account(
    http_response: HTTPResponse, config: Config
) -> DescribeCloudAccountOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_describe_cloud_account(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_deleted_at := output.get("deletedAt")) is not None:
        kwargs["deleted_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _deleted_at)
        )

    if (_created_at := output.get("createdAt")) is not None:
        kwargs["created_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _created_at)
        )

    if (_cloud_account_id := output.get("cloudAccountId")) is not None:
        kwargs["cloud_account_id"] = expect_type(str, _cloud_account_id)

    if (_permissions := output.get("permissions")) is not None:
        kwargs["permissions"] = _deserialize_account_permissions(_permissions, config)

    if (_data_plane_ids := output.get("dataPlaneIds")) is not None:
        kwargs["data_plane_ids"] = _deserialize_data_plane_ids(_data_plane_ids, config)

    if (_meta := output.get("meta")) is not None:
        kwargs["meta"] = _deserialize_open_properties(_meta, config)

    if (_type := output.get("type")) is not None:
        kwargs["type"] = expect_type(str, _type)

    if "accountId" not in output:
        raise ServiceError(
            'Expected to find "accountId" in the operation output, but it was not present.'
        )
    kwargs["account_id"] = expect_type(str, output["accountId"])

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_updated_at := output.get("updatedAt")) is not None:
        kwargs["updated_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _updated_at)
        )

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    return DescribeCloudAccountOutput(**kwargs)


async def _deserialize_error_describe_cloud_account(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_describe_connector(
    http_response: HTTPResponse, config: Config
) -> DescribeConnectorOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_describe_connector(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_updated_at := output.get("updatedAt")) is not None:
        kwargs["updated_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _updated_at)
        )

    if (_meta_data_sync_interval := output.get("metaDataSyncInterval")) is not None:
        kwargs["meta_data_sync_interval"] = expect_type(str, _meta_data_sync_interval)

    if (_params := output.get("params")) is not None:
        kwargs["params"] = _deserialize_open_properties(_params, config)

    if "connectorId" not in output:
        raise ServiceError(
            'Expected to find "connectorId" in the operation output, but it was not present.'
        )
    kwargs["connector_id"] = expect_type(str, output["connectorId"])

    if (_data_plane_id := output.get("dataPlaneId")) is not None:
        kwargs["data_plane_id"] = expect_type(str, _data_plane_id)

    if (_resource_id := output.get("resourceId")) is not None:
        kwargs["resource_id"] = expect_type(str, _resource_id)

    if (_connector_type := output.get("connectorType")) is not None:
        kwargs["connector_type"] = expect_type(str, _connector_type)

    if (
        _next_meta_data_sync_schedule := output.get("nextMetaDataSyncSchedule")
    ) is not None:
        kwargs["next_meta_data_sync_schedule"] = epoch_seconds_to_datetime(
            expect_type(int | float, _next_meta_data_sync_schedule)
        )

    if (_is_meta_data_sync_running := output.get("isMetaDataSyncRunning")) is not None:
        kwargs["is_meta_data_sync_running"] = expect_type(
            bool, _is_meta_data_sync_running
        )

    if (_created_at := output.get("createdAt")) is not None:
        kwargs["created_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _created_at)
        )

    if (_resource_type := output.get("resourceType")) is not None:
        kwargs["resource_type"] = expect_type(str, _resource_type)

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_resource_account_id := output.get("resourceAccountId")) is not None:
        kwargs["resource_account_id"] = expect_type(str, _resource_account_id)

    if (_state := output.get("state")) is not None:
        kwargs["state"] = expect_type(str, _state)

    if (_region := output.get("region")) is not None:
        kwargs["region"] = expect_type(str, _region)

    return DescribeConnectorOutput(**kwargs)


async def _deserialize_error_describe_connector(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_describe_department(
    http_response: HTTPResponse, config: Config
) -> DescribeDepartmentOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_describe_department(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "name" not in output:
        raise ServiceError(
            'Expected to find "name" in the operation output, but it was not present.'
        )
    kwargs["name"] = expect_type(str, output["name"])

    if "departmentId" not in output:
        raise ServiceError(
            'Expected to find "departmentId" in the operation output, but it was not present.'
        )
    kwargs["department_id"] = expect_type(str, output["departmentId"])

    return DescribeDepartmentOutput(**kwargs)


async def _deserialize_error_describe_department(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_describe_discovered_recipient(
    http_response: HTTPResponse, config: Config
) -> DescribeDiscoveredRecipientOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_describe_discovered_recipient(
            http_response, config
        )

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "recipientModelId" not in output:
        raise ServiceError(
            'Expected to find "recipientModelId" in the operation output, but it was not present.'
        )
    kwargs["recipient_model_id"] = expect_type(str, output["recipientModelId"])

    if "discoveredRecipientId" not in output:
        raise ServiceError(
            'Expected to find "discoveredRecipientId" in the operation output, but it was not present.'
        )
    kwargs["discovered_recipient_id"] = expect_type(
        str, output["discoveredRecipientId"]
    )

    if "createdAt" not in output:
        raise ServiceError(
            'Expected to find "createdAt" in the operation output, but it was not present.'
        )
    kwargs["created_at"] = epoch_seconds_to_datetime(
        expect_type(int | float, output["createdAt"])
    )

    if "discoverySource" not in output:
        raise ServiceError(
            'Expected to find "discoverySource" in the operation output, but it was not present.'
        )
    kwargs["discovery_source"] = _deserialize_discovery_source_list(
        output["discoverySource"], config
    )

    return DescribeDiscoveredRecipientOutput(**kwargs)


async def _deserialize_error_describe_discovered_recipient(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_describe_domain(
    http_response: HTTPResponse, config: Config
) -> DescribeDomainOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_describe_domain(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_frequency := output.get("frequency")) is not None:
        kwargs["frequency"] = expect_type(str, _frequency)

    if (_created_at := output.get("createdAt")) is not None:
        kwargs["created_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _created_at)
        )

    if "domainId" not in output:
        raise ServiceError(
            'Expected to find "domainId" in the operation output, but it was not present.'
        )
    kwargs["domain_id"] = expect_type(str, output["domainId"])

    if (_recipients := output.get("recipients")) is not None:
        kwargs["recipients"] = _deserialize_recipients_discovered_of_domain_list(
            _recipients, config
        )

    if (_updated_at := output.get("updatedAt")) is not None:
        kwargs["updated_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _updated_at)
        )

    return DescribeDomainOutput(**kwargs)


async def _deserialize_error_describe_domain(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_describe_dpia(
    http_response: HTTPResponse, config: Config
) -> DescribeDpiaOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_describe_dpia(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_privacy_framework := output.get("privacyFramework")) is not None:
        kwargs["privacy_framework"] = _deserialize_dpia_privacy_framework(
            _privacy_framework, config
        )

    if (_availability := output.get("availability")) is not None:
        kwargs["availability"] = _deserialize_dpia_availability_risk(
            _availability, config
        )

    if (_integrity := output.get("integrity")) is not None:
        kwargs["integrity"] = _deserialize_dpia_integrity_risk(_integrity, config)

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_additional_information := output.get("additionalInformation")) is not None:
        kwargs["additional_information"] = expect_type(str, _additional_information)

    if (
        _additional_information_files := output.get("additionalInformationFiles")
    ) is not None:
        kwargs["additional_information_files"] = _deserialize_uuid_collection(
            _additional_information_files, config
        )

    if (_confidentiality := output.get("confidentiality")) is not None:
        kwargs["confidentiality"] = _deserialize_dpia_confidentiality_risk(
            _confidentiality, config
        )

    return DescribeDpiaOutput(**kwargs)


async def _deserialize_error_describe_dpia(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_describe_employee(
    http_response: HTTPResponse, config: Config
) -> DescribeEmployeeOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_describe_employee(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_nif := output.get("nif")) is not None:
        kwargs["nif"] = expect_type(str, _nif)

    if (_manager_object := output.get("managerObject")) is not None:
        kwargs["manager_object"] = _deserialize_manager_object(_manager_object, config)

    if "surname" not in output:
        raise ServiceError(
            'Expected to find "surname" in the operation output, but it was not present.'
        )
    kwargs["surname"] = expect_type(str, output["surname"])

    if "employeeId" not in output:
        raise ServiceError(
            'Expected to find "employeeId" in the operation output, but it was not present.'
        )
    kwargs["employee_id"] = expect_type(str, output["employeeId"])

    if "createdBy" not in output:
        raise ServiceError(
            'Expected to find "createdBy" in the operation output, but it was not present.'
        )
    kwargs["created_by"] = expect_type(str, output["createdBy"])

    if (_manager := output.get("manager")) is not None:
        kwargs["manager"] = expect_type(str, _manager)

    if (_end_date := output.get("endDate")) is not None:
        kwargs["end_date"] = expect_type(str, _end_date)

    if (_department_object := output.get("departmentObject")) is not None:
        kwargs["department_object"] = _deserialize_department_object(
            _department_object, config
        )

    if (_reference_id := output.get("referenceId")) is not None:
        kwargs["reference_id"] = expect_type(str, _reference_id)

    if (_position := output.get("position")) is not None:
        kwargs["position"] = expect_type(str, _position)

    if "name" not in output:
        raise ServiceError(
            'Expected to find "name" in the operation output, but it was not present.'
        )
    kwargs["name"] = expect_type(str, output["name"])

    if (_start_date := output.get("startDate")) is not None:
        kwargs["start_date"] = expect_type(str, _start_date)

    if (_email := output.get("email")) is not None:
        kwargs["email"] = expect_type(str, _email)

    if (_department := output.get("department")) is not None:
        kwargs["department"] = expect_type(str, _department)

    return DescribeEmployeeOutput(**kwargs)


async def _deserialize_error_describe_employee(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_describe_headquarter(
    http_response: HTTPResponse, config: Config
) -> DescribeHeadquarterOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_describe_headquarter(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_city := output.get("city")) is not None:
        kwargs["city"] = expect_type(str, _city)

    if (_country := output.get("country")) is not None:
        kwargs["country"] = expect_type(str, _country)

    if (_zipcode := output.get("zipcode")) is not None:
        kwargs["zipcode"] = expect_type(str, _zipcode)

    if (_address := output.get("address")) is not None:
        kwargs["address"] = expect_type(str, _address)

    if "headquarterId" not in output:
        raise ServiceError(
            'Expected to find "headquarterId" in the operation output, but it was not present.'
        )
    kwargs["headquarter_id"] = expect_type(str, output["headquarterId"])

    if (_toms := output.get("toms")) is not None:
        kwargs["toms"] = _deserialize_tom_collection(_toms, config)

    return DescribeHeadquarterOutput(**kwargs)


async def _deserialize_error_describe_headquarter(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_describe_inspection_result(
    http_response: HTTPResponse, config: Config
) -> DescribeInspectionResultOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_describe_inspection_result(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_resource_name := output.get("resourceName")) is not None:
        kwargs["resource_name"] = expect_type(str, _resource_name)

    if (_has_finding := output.get("hasFinding")) is not None:
        kwargs["has_finding"] = expect_type(bool, _has_finding)

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_user_email := output.get("userEmail")) is not None:
        kwargs["user_email"] = expect_type(str, _user_email)

    if (_file_name := output.get("fileName")) is not None:
        kwargs["file_name"] = expect_type(str, _file_name)

    if (_sample_tokens := output.get("sampleTokens")) is not None:
        kwargs["sample_tokens"] = _deserialize_tokens(_sample_tokens, config)

    if (_resource_id := output.get("resourceId")) is not None:
        kwargs["resource_id"] = expect_type(str, _resource_id)

    if (_scan_id := output.get("scanId")) is not None:
        kwargs["scan_id"] = expect_type(str, _scan_id)

    if (_parent_id := output.get("parentId")) is not None:
        kwargs["parent_id"] = expect_type(str, _parent_id)

    if (_user_name := output.get("userName")) is not None:
        kwargs["user_name"] = expect_type(str, _user_name)

    if (_scan_parameters := output.get("scanParameters")) is not None:
        kwargs["scan_parameters"] = _deserialize_scan_parameters(
            _scan_parameters, config
        )

    if (_tokens := output.get("tokens")) is not None:
        kwargs["tokens"] = _deserialize_tokens(_tokens, config)

    if (_meta := output.get("meta")) is not None:
        kwargs["meta"] = _deserialize_open_properties(_meta, config)

    if "id" not in output:
        raise ServiceError(
            'Expected to find "id" in the operation output, but it was not present.'
        )
    kwargs["id"] = expect_type(str, output["id"])

    if (_scan_iteration_id := output.get("scanIterationId")) is not None:
        kwargs["scan_iteration_id"] = expect_type(str, _scan_iteration_id)

    if (_stats := output.get("stats")) is not None:
        kwargs["stats"] = _deserialize_record_type(_stats, config)

    if (_compliance := output.get("compliance")) is not None:
        kwargs["compliance"] = _deserialize_compliance_detail_list(_compliance, config)

    if (_updated_at := output.get("updatedAt")) is not None:
        kwargs["updated_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _updated_at)
        )

    if (_created_at := output.get("createdAt")) is not None:
        kwargs["created_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _created_at)
        )

    if (_resource_type := output.get("resourceType")) is not None:
        kwargs["resource_type"] = expect_type(str, _resource_type)

    if (_snapshot := output.get("snapshot")) is not None:
        kwargs["snapshot"] = _deserialize_inspection_result_snapshot(_snapshot, config)

    return DescribeInspectionResultOutput(**kwargs)


async def _deserialize_error_describe_inspection_result(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_describe_inventory_resource(
    http_response: HTTPResponse, config: Config
) -> DescribeInventoryResourceOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_describe_inventory_resource(
            http_response, config
        )

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_meta := output.get("meta")) is not None:
        kwargs["meta"] = _deserialize_open_properties(_meta, config)

    if (_source := output.get("source")) is not None:
        kwargs["source"] = expect_type(str, _source)

    if (_aka := output.get("aka")) is not None:
        kwargs["aka"] = expect_type(str, _aka)

    if (_last_updated := output.get("lastUpdated")) is not None:
        kwargs["last_updated"] = expect_type(str, _last_updated)

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_properties := output.get("properties")) is not None:
        kwargs["properties"] = _deserialize_open_properties(_properties, config)

    if (_owner := output.get("owner")) is not None:
        kwargs["owner"] = _deserialize_owner_object_list(_owner, config)

    if "resourceId" not in output:
        raise ServiceError(
            'Expected to find "resourceId" in the operation output, but it was not present.'
        )
    kwargs["resource_id"] = expect_type(str, output["resourceId"])

    if (_first_seen := output.get("firstSeen")) is not None:
        kwargs["first_seen"] = expect_type(str, _first_seen)

    if (_data_categories := output.get("dataCategories")) is not None:
        kwargs["data_categories"] = _deserialize_unique_string_list(
            _data_categories, config
        )

    if (_severity_score := output.get("severityScore")) is not None:
        kwargs["severity_score"] = expect_type(int, _severity_score)

    if (_issue_id := output.get("issueId")) is not None:
        kwargs["issue_id"] = expect_type(str, _issue_id)

    if (_scan := output.get("scan")) is not None:
        kwargs["scan"] = _deserialize_scan_information(_scan, config)

    if (_data_classification := output.get("dataClassification")) is not None:
        kwargs["data_classification"] = _deserialize_unique_string_list(
            _data_classification, config
        )

    if (_type := output.get("type")) is not None:
        kwargs["type"] = expect_type(str, _type)

    if (_parent_id := output.get("parentId")) is not None:
        kwargs["parent_id"] = expect_type(str, _parent_id)

    if (_failed_rules := output.get("failedRules")) is not None:
        kwargs["failed_rules"] = _deserialize_unique_string_list(_failed_rules, config)

    return DescribeInventoryResourceOutput(**kwargs)


async def _deserialize_error_describe_inventory_resource(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_describe_issue(
    http_response: HTTPResponse, config: Config
) -> DescribeIssueOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_describe_issue(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_compliance_risk := output.get("complianceRisk")) is not None:
        kwargs["compliance_risk"] = _deserialize_compliance_risk(
            _compliance_risk, config
        )

    if (_events := output.get("events")) is not None:
        kwargs["events"] = _deserialize_data_security_event_list(_events, config)

    if (_notifications := output.get("notifications")) is not None:
        kwargs["notifications"] = _deserialize_issue_notification_list(
            _notifications, config
        )

    if (_created_at := output.get("createdAt")) is not None:
        kwargs["created_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _created_at)
        )

    if "issueId" not in output:
        raise ServiceError(
            'Expected to find "issueId" in the operation output, but it was not present.'
        )
    kwargs["issue_id"] = expect_type(str, output["issueId"])

    if (_state := output.get("state")) is not None:
        kwargs["state"] = expect_type(str, _state)

    if (_security_risk := output.get("securityRisk")) is not None:
        kwargs["security_risk"] = _deserialize_security_risk(_security_risk, config)

    if (_severity := output.get("severity")) is not None:
        kwargs["severity"] = expect_type(str, _severity)

    if (_resource := output.get("resource")) is not None:
        kwargs["resource"] = _deserialize_issue_resource_details(_resource, config)

    if (_resource_id := output.get("resourceId")) is not None:
        kwargs["resource_id"] = expect_type(str, _resource_id)

    if (_updated_at := output.get("updatedAt")) is not None:
        kwargs["updated_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _updated_at)
        )

    return DescribeIssueOutput(**kwargs)


async def _deserialize_error_describe_issue(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_describe_processing_activity(
    http_response: HTTPResponse, config: Config
) -> DescribeProcessingActivityOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_describe_processing_activity(
            http_response, config
        )

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_language := output.get("language")) is not None:
        kwargs["language"] = expect_type(str, _language)

    if (_data_subjects := output.get("dataSubjects")) is not None:
        kwargs["data_subjects"] = _deserialize_data_subject_collection(
            _data_subjects, config
        )

    if (_additional_info := output.get("additionalInfo")) is not None:
        kwargs["additional_info"] = expect_type(str, _additional_info)

    if (_model_id := output.get("modelId")) is not None:
        kwargs["model_id"] = expect_type(str, _model_id)

    if (_created_at := output.get("createdAt")) is not None:
        kwargs["created_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _created_at)
        )

    if (_retention_period := output.get("retentionPeriod")) is not None:
        kwargs["retention_period"] = _deserialize_retention_period(
            _retention_period, config
        )

    if (_data_sources := output.get("dataSources")) is not None:
        kwargs["data_sources"] = (
            _deserialize_processing_activitiy_data_source_collection(
                _data_sources, config
            )
        )

    if (_management_methods := output.get("managementMethods")) is not None:
        kwargs["management_methods"] = _deserialize_management_method_collection(
            _management_methods, config
        )

    if (_lawful_basis := output.get("lawfulBasis")) is not None:
        kwargs["lawful_basis"] = _deserialize_lawful_basis_collection(
            _lawful_basis, config
        )

    if (_contact_person_employee := output.get("contactPersonEmployee")) is not None:
        kwargs["contact_person_employee"] = _deserialize_processing_activity_employee(
            _contact_person_employee, config
        )

    if (_infotypes := output.get("infotypes")) is not None:
        kwargs["infotypes"] = _deserialize_infotypes_list(_infotypes, config)

    if (_infotype_volume := output.get("infotypeVolume")) is not None:
        kwargs["infotype_volume"] = expect_type(str, _infotype_volume)

    if "processingActivityId" not in output:
        raise ServiceError(
            'Expected to find "processingActivityId" in the operation output, but it was not present.'
        )
    kwargs["processing_activity_id"] = expect_type(str, output["processingActivityId"])

    if (_updated_at := output.get("updatedAt")) is not None:
        kwargs["updated_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _updated_at)
        )

    if (_additional_info_files := output.get("additionalInfoFiles")) is not None:
        kwargs["additional_info_files"] = _deserialize_uuid_collection(
            _additional_info_files, config
        )

    if (_processing_frequency := output.get("processingFrequency")) is not None:
        kwargs["processing_frequency"] = expect_type(str, _processing_frequency)

    if (
        _are_access_requests_managed := output.get("areAccessRequestsManaged")
    ) is not None:
        kwargs["are_access_requests_managed"] = expect_type(
            bool, _are_access_requests_managed
        )

    if (_data_types := output.get("dataTypes")) is not None:
        kwargs["data_types"] = _deserialize_data_type_collection(_data_types, config)

    if (_is_data_stored := output.get("isDataStored")) is not None:
        kwargs["is_data_stored"] = expect_type(bool, _is_data_stored)

    if (_asset_objects := output.get("assetObjects")) is not None:
        kwargs["asset_objects"] = _deserialize_processing_activity_asset_list(
            _asset_objects, config
        )

    if (_created_by := output.get("createdBy")) is not None:
        kwargs["created_by"] = expect_type(str, _created_by)

    if (_company_role := output.get("companyRole")) is not None:
        kwargs["company_role"] = expect_type(str, _company_role)

    if (
        _processing_frequency_comment := output.get("processingFrequencyComment")
    ) is not None:
        kwargs["processing_frequency_comment"] = expect_type(
            str, _processing_frequency_comment
        )

    if (_retention_period_comment := output.get("retentionPeriodComment")) is not None:
        kwargs["retention_period_comment"] = expect_type(str, _retention_period_comment)

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_recipient_objects := output.get("recipientObjects")) is not None:
        kwargs["recipient_objects"] = _deserialize_processing_activity_recipient_list(
            _recipient_objects, config
        )

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_department_objects := output.get("departmentObjects")) is not None:
        kwargs["department_objects"] = _deserialize_processing_activity_department_list(
            _department_objects, config
        )

    if (_infotype_categories := output.get("infotypeCategories")) is not None:
        kwargs["infotype_categories"] = _deserialize_infotype_category_list(
            _infotype_categories, config
        )

    if (_active := output.get("active")) is not None:
        kwargs["active"] = expect_type(bool, _active)

    if (_purpose := output.get("purpose")) is not None:
        kwargs["purpose"] = expect_type(str, _purpose)

    return DescribeProcessingActivityOutput(**kwargs)


async def _deserialize_error_describe_processing_activity(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_describe_recipient(
    http_response: HTTPResponse, config: Config
) -> DescribeRecipientOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_describe_recipient(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_data_storage_location := output.get("dataStorageLocation")) is not None:
        kwargs["data_storage_location"] = _deserialize_country_list(
            _data_storage_location, config
        )

    if (_recipient_model_id := output.get("recipientModelId")) is not None:
        kwargs["recipient_model_id"] = expect_type(str, _recipient_model_id)

    if (_recipient_warranties := output.get("recipientWarranties")) is not None:
        kwargs["recipient_warranties"] = _deserialize_warranty_list(
            _recipient_warranties, config
        )

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_categories := output.get("categories")) is not None:
        kwargs["categories"] = _deserialize_recipient_category_collection(
            _categories, config
        )

    if (_dpa_files := output.get("dpaFiles")) is not None:
        kwargs["dpa_files"] = _deserialize_uuid_collection(_dpa_files, config)

    if (_country := output.get("country")) is not None:
        kwargs["country"] = expect_type(str, _country)

    if (_discovery_source := output.get("discoverySource")) is not None:
        kwargs["discovery_source"] = _deserialize_discovery_source_list(
            _discovery_source, config
        )

    if (_role := output.get("role")) is not None:
        kwargs["role"] = expect_type(str, _role)

    if (_state := output.get("state")) is not None:
        kwargs["state"] = expect_type(str, _state)

    if (_business_name := output.get("businessName")) is not None:
        kwargs["business_name"] = expect_type(str, _business_name)

    if (_dpa_status := output.get("dpaStatus")) is not None:
        kwargs["dpa_status"] = expect_type(str, _dpa_status)

    if (_dpa := output.get("dpa")) is not None:
        kwargs["dpa"] = expect_type(str, _dpa)

    if (_discovered_date := output.get("discoveredDate")) is not None:
        kwargs["discovered_date"] = epoch_seconds_to_datetime(
            expect_type(int | float, _discovered_date)
        )

    return DescribeRecipientOutput(**kwargs)


async def _deserialize_error_describe_recipient(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_describe_scan(
    http_response: HTTPResponse, config: Config
) -> DescribeScanOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_describe_scan(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_scan_type := output.get("scanType")) is not None:
        kwargs["scan_type"] = expect_type(str, _scan_type)

    if (_data_plane_id := output.get("dataPlaneId")) is not None:
        kwargs["data_plane_id"] = expect_type(str, _data_plane_id)

    if (_snapshot := output.get("snapshot")) is not None:
        kwargs["snapshot"] = _deserialize_inspection_result_snapshot(_snapshot, config)

    if (_elapsed_time_ms := output.get("elapsedTimeMs")) is not None:
        kwargs["elapsed_time_ms"] = expect_type(int, _elapsed_time_ms)

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_cron := output.get("cron")) is not None:
        kwargs["cron"] = expect_type(str, _cron)

    if (_data_plane_slug := output.get("dataPlaneSlug")) is not None:
        kwargs["data_plane_slug"] = expect_type(str, _data_plane_slug)

    if (_schedule := output.get("schedule")) is not None:
        kwargs["schedule"] = _deserialize_scan_schedule(_schedule, config)

    if (_schedule_type := output.get("scheduleType")) is not None:
        kwargs["schedule_type"] = expect_type(str, _schedule_type)

    if (_scan_filter := output.get("scanFilter")) is not None:
        kwargs["scan_filter"] = _deserialize_scan_filter_list(_scan_filter, config)

    if (_inspection_policy := output.get("inspectionPolicy")) is not None:
        kwargs["inspection_policy"] = _deserialize_inspection_policy(
            _inspection_policy, config
        )

    if "scanId" not in output:
        raise ServiceError(
            'Expected to find "scanId" in the operation output, but it was not present.'
        )
    kwargs["scan_id"] = expect_type(str, output["scanId"])

    if (_connector_id := output.get("connectorId")) is not None:
        kwargs["connector_id"] = expect_type(str, _connector_id)

    if (_data_plane_name := output.get("dataPlaneName")) is not None:
        kwargs["data_plane_name"] = expect_type(str, _data_plane_name)

    if (_meta := output.get("meta")) is not None:
        kwargs["meta"] = _deserialize_scan_meta(_meta, config)

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_resources := output.get("resources")) is not None:
        kwargs["resources"] = _deserialize_scan_resources(_resources, config)

    if (_scan_limits := output.get("scanLimits")) is not None:
        kwargs["scan_limits"] = _deserialize_scan_limits(_scan_limits, config)

    if (_next_execution := output.get("nextExecution")) is not None:
        kwargs["next_execution"] = epoch_seconds_to_datetime(
            expect_type(int | float, _next_execution)
        )

    if (_resource_type := output.get("resourceType")) is not None:
        kwargs["resource_type"] = expect_type(str, _resource_type)

    if (_updated_at := output.get("updatedAt")) is not None:
        kwargs["updated_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _updated_at)
        )

    if (_created_at := output.get("createdAt")) is not None:
        kwargs["created_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _created_at)
        )

    if (_connector_type := output.get("connectorType")) is not None:
        kwargs["connector_type"] = expect_type(str, _connector_type)

    if (_stats := output.get("stats")) is not None:
        kwargs["stats"] = _deserialize_scan_stats(_stats, config)

    return DescribeScanOutput(**kwargs)


async def _deserialize_error_describe_scan(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_describe_threshold(
    http_response: HTTPResponse, config: Config
) -> DescribeThresholdOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_describe_threshold(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (
        _extensive_automated_evaluation_characteristics := output.get(
            "extensiveAutomatedEvaluationCharacteristics"
        )
    ) is not None:
        kwargs["extensive_automated_evaluation_characteristics"] = expect_type(
            bool, _extensive_automated_evaluation_characteristics
        )

    if (
        _processing_confidential_sensitive_data := output.get(
            "processingConfidentialSensitiveData"
        )
    ) is not None:
        kwargs["processing_confidential_sensitive_data"] = expect_type(
            bool, _processing_confidential_sensitive_data
        )

    if (
        _matching_merging_records_involved := output.get(
            "matchingMergingRecordsInvolved"
        )
    ) is not None:
        kwargs["matching_merging_records_involved"] = expect_type(
            bool, _matching_merging_records_involved
        )

    if (
        _innovative_technologies_used := output.get("innovativeTechnologiesUsed")
    ) is not None:
        kwargs["innovative_technologies_used"] = expect_type(
            bool, _innovative_technologies_used
        )

    if (
        _prevent_data_subjects_exercising_their_rights := output.get(
            "preventDataSubjectsExercisingTheirRights"
        )
    ) is not None:
        kwargs["prevent_data_subjects_exercising_their_rights"] = expect_type(
            bool, _prevent_data_subjects_exercising_their_rights
        )

    if (_classifying_data_subject := output.get("classifyingDataSubject")) is not None:
        kwargs["classifying_data_subject"] = expect_type(
            bool, _classifying_data_subject
        )

    if (
        _automated_decision_making := output.get("automatedDecisionMaking")
    ) is not None:
        kwargs["automated_decision_making"] = expect_type(
            bool, _automated_decision_making
        )

    if (_blacklist := output.get("blacklist")) is not None:
        kwargs["blacklist"] = expect_type(bool, _blacklist)

    if (
        _systematic_monitoring_data_subject := output.get(
            "systematicMonitoringDataSubject"
        )
    ) is not None:
        kwargs["systematic_monitoring_data_subject"] = expect_type(
            bool, _systematic_monitoring_data_subject
        )

    if (
        _large_scale_processing_sensitive_data := output.get(
            "largeScaleProcessingSensitiveData"
        )
    ) is not None:
        kwargs["large_scale_processing_sensitive_data"] = expect_type(
            bool, _large_scale_processing_sensitive_data
        )

    if (
        _monitoring_publicly_accessible_areas := output.get(
            "monitoringPubliclyAccessibleAreas"
        )
    ) is not None:
        kwargs["monitoring_publicly_accessible_areas"] = expect_type(
            bool, _monitoring_publicly_accessible_areas
        )

    if (
        _large_scale_data_processing := output.get("largeScaleDataProcessing")
    ) is not None:
        kwargs["large_scale_data_processing"] = expect_type(
            bool, _large_scale_data_processing
        )

    if (_comment := output.get("comment")) is not None:
        kwargs["comment"] = expect_type(str, _comment)

    if (_dpia_status := output.get("dpiaStatus")) is not None:
        kwargs["dpia_status"] = expect_type(str, _dpia_status)

    if (
        _processing_vulnerable_data_subject := output.get(
            "processingVulnerableDataSubject"
        )
    ) is not None:
        kwargs["processing_vulnerable_data_subject"] = expect_type(
            bool, _processing_vulnerable_data_subject
        )

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    return DescribeThresholdOutput(**kwargs)


async def _deserialize_error_describe_threshold(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_describe_tom(
    http_response: HTTPResponse, config: Config
) -> DescribeTomOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_describe_tom(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_note := output.get("note")) is not None:
        kwargs["note"] = expect_type(str, _note)

    if (_reference_code := output.get("referenceCode")) is not None:
        kwargs["reference_code"] = expect_type(str, _reference_code)

    if (_document_files := output.get("documentFiles")) is not None:
        kwargs["document_files"] = _deserialize_uuid_collection(_document_files, config)

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_object_category := output.get("objectCategory")) is not None:
        kwargs["object_category"] = expect_type(str, _object_category)

    if (_description := output.get("description")) is not None:
        kwargs["description"] = expect_type(str, _description)

    if (_list_ := output.get("list")) is not None:
        kwargs["list_"] = expect_type(str, _list_)

    if (_category := output.get("category")) is not None:
        kwargs["category"] = expect_type(str, _category)

    if (_type := output.get("type")) is not None:
        kwargs["type"] = expect_type(str, _type)

    return DescribeTomOutput(**kwargs)


async def _deserialize_error_describe_tom(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_describe_user_profile(
    http_response: HTTPResponse, config: Config
) -> DescribeUserProfileOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_describe_user_profile(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_connector_source_type := output.get("connectorSourceType")) is not None:
        kwargs["connector_source_type"] = expect_type(str, _connector_source_type)

    if (_created_at := output.get("createdAt")) is not None:
        kwargs["created_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _created_at)
        )

    if (_updated_at := output.get("updatedAt")) is not None:
        kwargs["updated_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _updated_at)
        )

    if (_connector_user_id := output.get("connectorUserId")) is not None:
        kwargs["connector_user_id"] = expect_type(str, _connector_user_id)

    if "userId" not in output:
        raise ServiceError(
            'Expected to find "userId" in the operation output, but it was not present.'
        )
    kwargs["user_id"] = expect_type(str, output["userId"])

    if (_external := output.get("external")) is not None:
        kwargs["external"] = expect_type(bool, _external)

    if (_connector_username := output.get("connectorUsername")) is not None:
        kwargs["connector_username"] = expect_type(str, _connector_username)

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_connector_id := output.get("connectorId")) is not None:
        kwargs["connector_id"] = expect_type(str, _connector_id)

    if (_email := output.get("email")) is not None:
        kwargs["email"] = expect_type(str, _email)

    if (_deleted_at := output.get("deletedAt")) is not None:
        kwargs["deleted_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _deleted_at)
        )

    return DescribeUserProfileOutput(**kwargs)


async def _deserialize_error_describe_user_profile(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_accounts(
    http_response: HTTPResponse, config: Config
) -> ListAccountsOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_accounts(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_total := output.get("total")) is not None:
        kwargs["total"] = expect_type(int, _total)

    if (_next_token := output.get("nextToken")) is not None:
        kwargs["next_token"] = expect_type(str, _next_token)

    if (_accounts := output.get("accounts")) is not None:
        kwargs["accounts"] = _deserialize_accounts_list(_accounts, config)

    return ListAccountsOutput(**kwargs)


async def _deserialize_error_list_accounts(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_assets(
    http_response: HTTPResponse, config: Config
) -> ListAssetsOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_assets(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "total" not in output:
        raise ServiceError(
            'Expected to find "total" in the operation output, but it was not present.'
        )
    kwargs["total"] = expect_type(int, output["total"])

    if (_next_token := output.get("nextToken")) is not None:
        kwargs["next_token"] = expect_type(str, _next_token)

    if "assets" not in output:
        raise ServiceError(
            'Expected to find "assets" in the operation output, but it was not present.'
        )
    kwargs["assets"] = _deserialize_asset_list(output["assets"], config)

    return ListAssetsOutput(**kwargs)


async def _deserialize_error_list_assets(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_catalog_leaf_resources(
    http_response: HTTPResponse, config: Config
) -> ListCatalogLeafResourcesOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_catalog_leaf_resources(
            http_response, config
        )

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_resources := output.get("resources")) is not None:
        kwargs["resources"] = _deserialize_leaf_resources_data_list(_resources, config)

    if (_count := output.get("count")) is not None:
        kwargs["count"] = expect_type(int, _count)

    if (_next_token := output.get("nextToken")) is not None:
        kwargs["next_token"] = expect_type(str, _next_token)

    return ListCatalogLeafResourcesOutput(**kwargs)


async def _deserialize_error_list_catalog_leaf_resources(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_catalog_leaf_resources_export(
    http_response: HTTPResponse, config: Config
) -> ListCatalogLeafResourcesExportOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_catalog_leaf_resources_export(
            http_response, config
        )

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_url := output.get("url")) is not None:
        kwargs["url"] = expect_type(str, _url)

    return ListCatalogLeafResourcesExportOutput(**kwargs)


async def _deserialize_error_list_catalog_leaf_resources_export(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_connectors(
    http_response: HTTPResponse, config: Config
) -> ListConnectorsOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_connectors(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_next_token := output.get("nextToken")) is not None:
        kwargs["next_token"] = expect_type(str, _next_token)

    if (_connectors := output.get("connectors")) is not None:
        kwargs["connectors"] = _deserialize_connectors_list(_connectors, config)

    if (_total := output.get("total")) is not None:
        kwargs["total"] = expect_type(int, _total)

    return ListConnectorsOutput(**kwargs)


async def _deserialize_error_list_connectors(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_departments(
    http_response: HTTPResponse, config: Config
) -> ListDepartmentsOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_departments(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "departments" not in output:
        raise ServiceError(
            'Expected to find "departments" in the operation output, but it was not present.'
        )
    kwargs["departments"] = _deserialize_department_list(output["departments"], config)

    if "total" not in output:
        raise ServiceError(
            'Expected to find "total" in the operation output, but it was not present.'
        )
    kwargs["total"] = expect_type(int, output["total"])

    if (_next_token := output.get("nextToken")) is not None:
        kwargs["next_token"] = expect_type(str, _next_token)

    return ListDepartmentsOutput(**kwargs)


async def _deserialize_error_list_departments(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_departments_for_filter(
    http_response: HTTPResponse, config: Config
) -> ListDepartmentsForFilterOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_departments_for_filter(
            http_response, config
        )

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "departments" not in output:
        raise ServiceError(
            'Expected to find "departments" in the operation output, but it was not present.'
        )
    kwargs["departments"] = _deserialize_department_for_filter_list(
        output["departments"], config
    )

    return ListDepartmentsForFilterOutput(**kwargs)


async def _deserialize_error_list_departments_for_filter(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_discovered_recipients(
    http_response: HTTPResponse, config: Config
) -> ListDiscoveredRecipientsOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_discovered_recipients(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_total := output.get("total")) is not None:
        kwargs["total"] = expect_type(int, _total)

    if (_discovered_recipients := output.get("discoveredRecipients")) is not None:
        kwargs["discovered_recipients"] = _deserialize_discovered_recipient_list(
            _discovered_recipients, config
        )

    if (_next_token := output.get("nextToken")) is not None:
        kwargs["next_token"] = expect_type(str, _next_token)

    return ListDiscoveredRecipientsOutput(**kwargs)


async def _deserialize_error_list_discovered_recipients(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_discovered_recipients_users(
    http_response: HTTPResponse, config: Config
) -> ListDiscoveredRecipientsUsersOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_discovered_recipients_users(
            http_response, config
        )

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_okta_users := output.get("oktaUsers")) is not None:
        kwargs["okta_users"] = _deserialize_okta_user_discovery_list(
            _okta_users, config
        )

    return ListDiscoveredRecipientsUsersOutput(**kwargs)


async def _deserialize_error_list_discovered_recipients_users(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_domains(
    http_response: HTTPResponse, config: Config
) -> ListDomainsOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_domains(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_next_token := output.get("nextToken")) is not None:
        kwargs["next_token"] = expect_type(str, _next_token)

    if (_domains := output.get("domains")) is not None:
        kwargs["domains"] = _deserialize_domain_list(_domains, config)

    if (_total := output.get("total")) is not None:
        kwargs["total"] = expect_type(int, _total)

    return ListDomainsOutput(**kwargs)


async def _deserialize_error_list_domains(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_employees(
    http_response: HTTPResponse, config: Config
) -> ListEmployeesOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_employees(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_next_token := output.get("nextToken")) is not None:
        kwargs["next_token"] = expect_type(str, _next_token)

    if "employees" not in output:
        raise ServiceError(
            'Expected to find "employees" in the operation output, but it was not present.'
        )
    kwargs["employees"] = _deserialize_employee_list(output["employees"], config)

    if "total" not in output:
        raise ServiceError(
            'Expected to find "total" in the operation output, but it was not present.'
        )
    kwargs["total"] = expect_type(int, output["total"])

    return ListEmployeesOutput(**kwargs)


async def _deserialize_error_list_employees(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_employees_for_filter(
    http_response: HTTPResponse, config: Config
) -> ListEmployeesForFilterOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_employees_for_filter(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "employees" not in output:
        raise ServiceError(
            'Expected to find "employees" in the operation output, but it was not present.'
        )
    kwargs["employees"] = _deserialize_employees_for_filter_list(
        output["employees"], config
    )

    return ListEmployeesForFilterOutput(**kwargs)


async def _deserialize_error_list_employees_for_filter(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_events(
    http_response: HTTPResponse, config: Config
) -> ListEventsOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_events(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_next_token := output.get("nextToken")) is not None:
        kwargs["next_token"] = expect_type(str, _next_token)

    if (_events := output.get("events")) is not None:
        kwargs["events"] = _deserialize_events_list(_events, config)

    if (_total := output.get("total")) is not None:
        kwargs["total"] = expect_type(int, _total)

    return ListEventsOutput(**kwargs)


async def _deserialize_error_list_events(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_headquarters(
    http_response: HTTPResponse, config: Config
) -> ListHeadquartersOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_headquarters(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "headquarters" not in output:
        raise ServiceError(
            'Expected to find "headquarters" in the operation output, but it was not present.'
        )
    kwargs["headquarters"] = _deserialize_headquarter_list(
        output["headquarters"], config
    )

    if "total" not in output:
        raise ServiceError(
            'Expected to find "total" in the operation output, but it was not present.'
        )
    kwargs["total"] = expect_type(int, output["total"])

    if (_next_token := output.get("nextToken")) is not None:
        kwargs["next_token"] = expect_type(str, _next_token)

    return ListHeadquartersOutput(**kwargs)


async def _deserialize_error_list_headquarters(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_infotype_categories(
    http_response: HTTPResponse, config: Config
) -> ListInfotypeCategoriesOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_infotype_categories(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_categories := output.get("categories")) is not None:
        kwargs["categories"] = _deserialize_category_list(_categories, config)

    return ListInfotypeCategoriesOutput(**kwargs)


async def _deserialize_error_list_infotype_categories(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_insights_filter(
    http_response: HTTPResponse, config: Config
) -> ListInsightsFilterOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_insights_filter(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_entries := output.get("entries")) is not None:
        kwargs["entries"] = _deserialize_insights_filter_value_parameter_list(
            _entries, config
        )

    return ListInsightsFilterOutput(**kwargs)


async def _deserialize_error_list_insights_filter(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_inspection_results(
    http_response: HTTPResponse, config: Config
) -> ListInspectionResultsOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_inspection_results(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_count := output.get("count")) is not None:
        kwargs["count"] = expect_type(int, _count)

    if (_next_token := output.get("nextToken")) is not None:
        kwargs["next_token"] = expect_type(str, _next_token)

    if (_inspection_results := output.get("inspectionResults")) is not None:
        kwargs["inspection_results"] = _deserialize_inspection_result_list(
            _inspection_results, config
        )

    return ListInspectionResultsOutput(**kwargs)


async def _deserialize_error_list_inspection_results(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_inventory_resources(
    http_response: HTTPResponse, config: Config
) -> ListInventoryResourcesOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_inventory_resources(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_next_token := output.get("nextToken")) is not None:
        kwargs["next_token"] = expect_type(str, _next_token)

    if (_resources := output.get("resources")) is not None:
        kwargs["resources"] = _deserialize_resource_inventory_list(_resources, config)

    if (_count := output.get("count")) is not None:
        kwargs["count"] = expect_type(int, _count)

    return ListInventoryResourcesOutput(**kwargs)


async def _deserialize_error_list_inventory_resources(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_inventory_resources_export(
    http_response: HTTPResponse, config: Config
) -> ListInventoryResourcesExportOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_inventory_resources_export(
            http_response, config
        )

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_url := output.get("url")) is not None:
        kwargs["url"] = expect_type(str, _url)

    return ListInventoryResourcesExportOutput(**kwargs)


async def _deserialize_error_list_inventory_resources_export(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_issues(
    http_response: HTTPResponse, config: Config
) -> ListIssuesOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_issues(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_issues := output.get("issues")) is not None:
        kwargs["issues"] = _deserialize_issue_list(_issues, config)

    if (_total := output.get("total")) is not None:
        kwargs["total"] = expect_type(int, _total)

    if (_next_token := output.get("nextToken")) is not None:
        kwargs["next_token"] = expect_type(str, _next_token)

    return ListIssuesOutput(**kwargs)


async def _deserialize_error_list_issues(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_logs(
    http_response: HTTPResponse, config: Config
) -> ListLogsOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_logs(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_next_token := output.get("nextToken")) is not None:
        kwargs["next_token"] = expect_type(str, _next_token)

    if (_logs := output.get("logs")) is not None:
        kwargs["logs"] = _deserialize_logs_results(_logs, config)

    if (_size := output.get("size")) is not None:
        kwargs["size"] = expect_type(int, _size)

    return ListLogsOutput(**kwargs)


async def _deserialize_error_list_logs(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_processing_activities(
    http_response: HTTPResponse, config: Config
) -> ListProcessingActivitiesOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_processing_activities(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "processingActivities" not in output:
        raise ServiceError(
            'Expected to find "processingActivities" in the operation output, but it was not present.'
        )
    kwargs["processing_activities"] = _deserialize_processing_activity_list(
        output["processingActivities"], config
    )

    if "total" not in output:
        raise ServiceError(
            'Expected to find "total" in the operation output, but it was not present.'
        )
    kwargs["total"] = expect_type(int, output["total"])

    if (_next_token := output.get("nextToken")) is not None:
        kwargs["next_token"] = expect_type(str, _next_token)

    return ListProcessingActivitiesOutput(**kwargs)


async def _deserialize_error_list_processing_activities(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_processing_activities_export(
    http_response: HTTPResponse, config: Config
) -> ListProcessingActivitiesExportOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_processing_activities_export(
            http_response, config
        )

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_url_list := output.get("urlList")) is not None:
        kwargs["url_list"] = _deserialize_url_list(_url_list, config)

    return ListProcessingActivitiesExportOutput(**kwargs)


async def _deserialize_error_list_processing_activities_export(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_processing_activities_of_recipient(
    http_response: HTTPResponse, config: Config
) -> ListProcessingActivitiesOfRecipientOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_processing_activities_of_recipient(
            http_response, config
        )

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_next_token := output.get("nextToken")) is not None:
        kwargs["next_token"] = expect_type(str, _next_token)

    if (
        _processing_activities_of_recipient := output.get(
            "processingActivitiesOfRecipient"
        )
    ) is not None:
        kwargs["processing_activities_of_recipient"] = (
            _deserialize_processing_activity_of_recipient_list(
                _processing_activities_of_recipient, config
            )
        )

    if (_total := output.get("total")) is not None:
        kwargs["total"] = expect_type(int, _total)

    return ListProcessingActivitiesOfRecipientOutput(**kwargs)


async def _deserialize_error_list_processing_activities_of_recipient(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_processing_activity_filter(
    http_response: HTTPResponse, config: Config
) -> ListProcessingActivityFilterOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_processing_activity_filter(
            http_response, config
        )

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_enteries := output.get("enteries")) is not None:
        kwargs["enteries"] = _deserialize_processing_activity_filter_output_list(
            _enteries, config
        )

    return ListProcessingActivityFilterOutput(**kwargs)


async def _deserialize_error_list_processing_activity_filter(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_recipient_filter(
    http_response: HTTPResponse, config: Config
) -> ListRecipientFilterOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_recipient_filter(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_entries := output.get("entries")) is not None:
        kwargs["entries"] = _deserialize_recipient_filter_output_list(_entries, config)

    return ListRecipientFilterOutput(**kwargs)


async def _deserialize_error_list_recipient_filter(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_recipients(
    http_response: HTTPResponse, config: Config
) -> ListRecipientsOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_recipients(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_recipients := output.get("recipients")) is not None:
        kwargs["recipients"] = _deserialize_recipient_list(_recipients, config)

    if (_next_token := output.get("nextToken")) is not None:
        kwargs["next_token"] = expect_type(str, _next_token)

    if (_total := output.get("total")) is not None:
        kwargs["total"] = expect_type(int, _total)

    return ListRecipientsOutput(**kwargs)


async def _deserialize_error_list_recipients(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_recipients_export(
    http_response: HTTPResponse, config: Config
) -> ListRecipientsExportOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_recipients_export(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_url_list := output.get("urlList")) is not None:
        kwargs["url_list"] = _deserialize_url_list(_url_list, config)

    return ListRecipientsExportOutput(**kwargs)


async def _deserialize_error_list_recipients_export(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_recipients_for_filter(
    http_response: HTTPResponse, config: Config
) -> ListRecipientsForFilterOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_recipients_for_filter(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_recipients := output.get("recipients")) is not None:
        kwargs["recipients"] = _deserialize_recipients_for_filter_list(
            _recipients, config
        )

    return ListRecipientsForFilterOutput(**kwargs)


async def _deserialize_error_list_recipients_for_filter(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_scans(
    http_response: HTTPResponse, config: Config
) -> ListScansOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_scans(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_total := output.get("total")) is not None:
        kwargs["total"] = expect_type(int, _total)

    if (_scans := output.get("scans")) is not None:
        kwargs["scans"] = _deserialize_scans_list(_scans, config)

    if (_next_token := output.get("nextToken")) is not None:
        kwargs["next_token"] = expect_type(str, _next_token)

    return ListScansOutput(**kwargs)


async def _deserialize_error_list_scans(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_toms(
    http_response: HTTPResponse, config: Config
) -> ListTomsOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_toms(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_toms := output.get("toms")) is not None:
        kwargs["toms"] = _deserialize_tom_collection(_toms, config)

    if (_total := output.get("total")) is not None:
        kwargs["total"] = expect_type(int, _total)

    if (_next_token := output.get("nextToken")) is not None:
        kwargs["next_token"] = expect_type(str, _next_token)

    return ListTomsOutput(**kwargs)


async def _deserialize_error_list_toms(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_list_user_profiles(
    http_response: HTTPResponse, config: Config
) -> ListUserProfilesOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_list_user_profiles(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_total := output.get("total")) is not None:
        kwargs["total"] = expect_type(int, _total)

    if (_user_profiles := output.get("userProfiles")) is not None:
        kwargs["user_profiles"] = _deserialize_user_profile_list(_user_profiles, config)

    if (_next_token := output.get("nextToken")) is not None:
        kwargs["next_token"] = expect_type(str, _next_token)

    return ListUserProfilesOutput(**kwargs)


async def _deserialize_error_list_user_profiles(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_page_insights_export(
    http_response: HTTPResponse, config: Config
) -> PageInsightsExportOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_page_insights_export(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_url := output.get("url")) is not None:
        kwargs["url"] = expect_type(str, _url)

    return PageInsightsExportOutput(**kwargs)


async def _deserialize_error_page_insights_export(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_pause_scan(
    http_response: HTTPResponse, config: Config
) -> PauseScanOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_pause_scan(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "scanId" not in output:
        raise ServiceError(
            'Expected to find "scanId" in the operation output, but it was not present.'
        )
    kwargs["scan_id"] = expect_type(str, output["scanId"])

    return PauseScanOutput(**kwargs)


async def _deserialize_error_pause_scan(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_poll_domain(
    http_response: HTTPResponse, config: Config
) -> PollDomainOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_poll_domain(http_response, config)

    kwargs: dict[str, Any] = {}

    return PollDomainOutput(**kwargs)


async def _deserialize_error_poll_domain(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_prepare_detailed_inspection_result(
    http_response: HTTPResponse, config: Config
) -> PrepareDetailedInspectionResultOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_prepare_detailed_inspection_result(
            http_response, config
        )

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_success := output.get("success")) is not None:
        kwargs["success"] = expect_type(bool, _success)

    if (_url := output.get("url")) is not None:
        kwargs["url"] = expect_type(str, _url)

    return PrepareDetailedInspectionResultOutput(**kwargs)


async def _deserialize_error_prepare_detailed_inspection_result(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_remove_asset(
    http_response: HTTPResponse, config: Config
) -> RemoveAssetOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_remove_asset(http_response, config)

    kwargs: dict[str, Any] = {}

    return RemoveAssetOutput(**kwargs)


async def _deserialize_error_remove_asset(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_remove_category(
    http_response: HTTPResponse, config: Config
) -> RemoveCategoryOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_remove_category(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "categoryLabel" not in output:
        raise ServiceError(
            'Expected to find "categoryLabel" in the operation output, but it was not present.'
        )
    kwargs["category_label"] = expect_type(str, output["categoryLabel"])

    return RemoveCategoryOutput(**kwargs)


async def _deserialize_error_remove_category(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_remove_department(
    http_response: HTTPResponse, config: Config
) -> RemoveDepartmentOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_remove_department(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "departmentId" not in output:
        raise ServiceError(
            'Expected to find "departmentId" in the operation output, but it was not present.'
        )
    kwargs["department_id"] = expect_type(str, output["departmentId"])

    return RemoveDepartmentOutput(**kwargs)


async def _deserialize_error_remove_department(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_remove_domain(
    http_response: HTTPResponse, config: Config
) -> RemoveDomainOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_remove_domain(http_response, config)

    kwargs: dict[str, Any] = {}

    return RemoveDomainOutput(**kwargs)


async def _deserialize_error_remove_domain(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_remove_dpia(
    http_response: HTTPResponse, config: Config
) -> RemoveDpiaOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_remove_dpia(http_response, config)

    kwargs: dict[str, Any] = {}

    return RemoveDpiaOutput(**kwargs)


async def _deserialize_error_remove_dpia(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_remove_employee(
    http_response: HTTPResponse, config: Config
) -> RemoveEmployeeOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_remove_employee(http_response, config)

    kwargs: dict[str, Any] = {}

    return RemoveEmployeeOutput(**kwargs)


async def _deserialize_error_remove_employee(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_remove_headquarter(
    http_response: HTTPResponse, config: Config
) -> RemoveHeadquarterOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_remove_headquarter(http_response, config)

    kwargs: dict[str, Any] = {}

    return RemoveHeadquarterOutput(**kwargs)


async def _deserialize_error_remove_headquarter(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_remove_processing_activity(
    http_response: HTTPResponse, config: Config
) -> RemoveProcessingActivityOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_remove_processing_activity(http_response, config)

    kwargs: dict[str, Any] = {}

    return RemoveProcessingActivityOutput(**kwargs)


async def _deserialize_error_remove_processing_activity(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_remove_recipient(
    http_response: HTTPResponse, config: Config
) -> RemoveRecipientOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_remove_recipient(http_response, config)

    kwargs: dict[str, Any] = {}

    return RemoveRecipientOutput(**kwargs)


async def _deserialize_error_remove_recipient(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_remove_threshold(
    http_response: HTTPResponse, config: Config
) -> RemoveThresholdOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_remove_threshold(http_response, config)

    kwargs: dict[str, Any] = {}

    return RemoveThresholdOutput(**kwargs)


async def _deserialize_error_remove_threshold(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_resume_scan(
    http_response: HTTPResponse, config: Config
) -> ResumeScanOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_resume_scan(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "scanId" not in output:
        raise ServiceError(
            'Expected to find "scanId" in the operation output, but it was not present.'
        )
    kwargs["scan_id"] = expect_type(str, output["scanId"])

    return ResumeScanOutput(**kwargs)


async def _deserialize_error_resume_scan(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_stop_scan(
    http_response: HTTPResponse, config: Config
) -> StopScanOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_stop_scan(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "scanId" not in output:
        raise ServiceError(
            'Expected to find "scanId" in the operation output, but it was not present.'
        )
    kwargs["scan_id"] = expect_type(str, output["scanId"])

    return StopScanOutput(**kwargs)


async def _deserialize_error_stop_scan(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_summarize_classification_stats(
    http_response: HTTPResponse, config: Config
) -> SummarizeClassificationStatsOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_summarize_classification_stats(
            http_response, config
        )

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_result := output.get("result")) is not None:
        kwargs["result"] = _deserialize_classification_stats(_result, config)

    return SummarizeClassificationStatsOutput(**kwargs)


async def _deserialize_error_summarize_classification_stats(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_summarize_resource_stats(
    http_response: HTTPResponse, config: Config
) -> SummarizeResourceStatsOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_summarize_resource_stats(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_result := output.get("result")) is not None:
        kwargs["result"] = _deserialize_resource_stats(_result, config)

    return SummarizeResourceStatsOutput(**kwargs)


async def _deserialize_error_summarize_resource_stats(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_untag_resources(
    http_response: HTTPResponse, config: Config
) -> UntagResourcesOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_untag_resources(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if (_results := output.get("results")) is not None:
        kwargs["results"] = _deserialize_tagging_results_list(_results, config)

    return UntagResourcesOutput(**kwargs)


async def _deserialize_error_untag_resources(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_update_asset(
    http_response: HTTPResponse, config: Config
) -> UpdateAssetOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_update_asset(http_response, config)

    kwargs: dict[str, Any] = {}

    return UpdateAssetOutput(**kwargs)


async def _deserialize_error_update_asset(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_update_category(
    http_response: HTTPResponse, config: Config
) -> UpdateCategoryOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_update_category(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "categoryLabel" not in output:
        raise ServiceError(
            'Expected to find "categoryLabel" in the operation output, but it was not present.'
        )
    kwargs["category_label"] = expect_type(str, output["categoryLabel"])

    return UpdateCategoryOutput(**kwargs)


async def _deserialize_error_update_category(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_update_department(
    http_response: HTTPResponse, config: Config
) -> UpdateDepartmentOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_update_department(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "departmentId" not in output:
        raise ServiceError(
            'Expected to find "departmentId" in the operation output, but it was not present.'
        )
    kwargs["department_id"] = expect_type(str, output["departmentId"])

    return UpdateDepartmentOutput(**kwargs)


async def _deserialize_error_update_department(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_update_domain(
    http_response: HTTPResponse, config: Config
) -> UpdateDomainOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_update_domain(http_response, config)

    kwargs: dict[str, Any] = {}

    return UpdateDomainOutput(**kwargs)


async def _deserialize_error_update_domain(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_update_dpia(
    http_response: HTTPResponse, config: Config
) -> UpdateDpiaOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_update_dpia(http_response, config)

    kwargs: dict[str, Any] = {}

    return UpdateDpiaOutput(**kwargs)


async def _deserialize_error_update_dpia(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_update_employee(
    http_response: HTTPResponse, config: Config
) -> UpdateEmployeeOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_update_employee(http_response, config)

    kwargs: dict[str, Any] = {}

    output: dict[str, DocumentValue] = {}
    if body := await http_response.consume_body_async():
        output = json.loads(body)

    if "employeeId" not in output:
        raise ServiceError(
            'Expected to find "employeeId" in the operation output, but it was not present.'
        )
    kwargs["employee_id"] = expect_type(str, output["employeeId"])

    return UpdateEmployeeOutput(**kwargs)


async def _deserialize_error_update_employee(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_update_headquarter(
    http_response: HTTPResponse, config: Config
) -> UpdateHeadquarterOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_update_headquarter(http_response, config)

    kwargs: dict[str, Any] = {}

    return UpdateHeadquarterOutput(**kwargs)


async def _deserialize_error_update_headquarter(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_update_processing_activity(
    http_response: HTTPResponse, config: Config
) -> UpdateProcessingActivityOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_update_processing_activity(http_response, config)

    kwargs: dict[str, Any] = {}

    return UpdateProcessingActivityOutput(**kwargs)


async def _deserialize_error_update_processing_activity(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_update_recipient(
    http_response: HTTPResponse, config: Config
) -> UpdateRecipientOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_update_recipient(http_response, config)

    kwargs: dict[str, Any] = {}

    return UpdateRecipientOutput(**kwargs)


async def _deserialize_error_update_recipient(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_update_threshold(
    http_response: HTTPResponse, config: Config
) -> UpdateThresholdOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_update_threshold(http_response, config)

    kwargs: dict[str, Any] = {}

    return UpdateThresholdOutput(**kwargs)


async def _deserialize_error_update_threshold(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_update_tom(
    http_response: HTTPResponse, config: Config
) -> UpdateTomOutput:
    if http_response.status != 200 and http_response.status >= 300:
        raise await _deserialize_error_update_tom(http_response, config)

    kwargs: dict[str, Any] = {}

    return UpdateTomOutput(**kwargs)


async def _deserialize_error_update_tom(
    http_response: HTTPResponse, config: Config
) -> ApiError:
    code, message, parsed_body = await parse_rest_json_error_info(http_response)

    match code.lower():
        case "unauthorized":
            return await _deserialize_error_unauthorized(
                http_response, config, parsed_body, message
            )

        case "validationexception":
            return await _deserialize_error_validation_exception(
                http_response, config, parsed_body, message
            )

        case "unexpectedservererror":
            return await _deserialize_error_unexpected_server_error(
                http_response, config, parsed_body, message
            )

        case "notallowed":
            return await _deserialize_error_not_allowed(
                http_response, config, parsed_body, message
            )

        case "nosuchresource":
            return await _deserialize_error_no_such_resource(
                http_response, config, parsed_body, message
            )

        case _:
            return UnknownApiError(message)


async def _deserialize_error_no_such_resource(
    http_response: HTTPResponse,
    config: Config,
    parsed_body: dict[str, DocumentValue] | None,
    default_message: str,
) -> NoSuchResource:
    kwargs: dict[str, Any] = {"message": default_message}

    if (parsed_body is None) and (body := await http_response.consume_body_async()):
        parsed_body = json.loads(body)

    output: dict[str, DocumentValue] = parsed_body if parsed_body is not None else {}

    if "resourceType" not in output:
        raise ServiceError(
            'Expected to find "resourceType" in the operation output, but it was not present.'
        )
    kwargs["resource_type"] = expect_type(str, output["resourceType"])

    return NoSuchResource(**kwargs)


async def _deserialize_error_not_allowed(
    http_response: HTTPResponse,
    config: Config,
    parsed_body: dict[str, DocumentValue] | None,
    default_message: str,
) -> NotAllowed:
    kwargs: dict[str, Any] = {"message": default_message}

    if (parsed_body is None) and (body := await http_response.consume_body_async()):
        parsed_body = json.loads(body)

    output: dict[str, DocumentValue] = parsed_body if parsed_body is not None else {}

    if "message" not in output:
        raise ServiceError(
            'Expected to find "message" in the operation output, but it was not present.'
        )
    kwargs["message"] = expect_type(str, output["message"])

    return NotAllowed(**kwargs)


async def _deserialize_error_unauthorized(
    http_response: HTTPResponse,
    config: Config,
    parsed_body: dict[str, DocumentValue] | None,
    default_message: str,
) -> Unauthorized:
    kwargs: dict[str, Any] = {"message": default_message}

    if (parsed_body is None) and (body := await http_response.consume_body_async()):
        parsed_body = json.loads(body)

    output: dict[str, DocumentValue] = parsed_body if parsed_body is not None else {}

    if (_message := output.get("message")) is not None:
        kwargs["message"] = expect_type(str, _message)

    return Unauthorized(**kwargs)


async def _deserialize_error_unexpected_server_error(
    http_response: HTTPResponse,
    config: Config,
    parsed_body: dict[str, DocumentValue] | None,
    default_message: str,
) -> UnexpectedServerError:
    kwargs: dict[str, Any] = {"message": default_message}

    if (parsed_body is None) and (body := await http_response.consume_body_async()):
        parsed_body = json.loads(body)

    output: dict[str, DocumentValue] = parsed_body if parsed_body is not None else {}

    if "message" not in output:
        raise ServiceError(
            'Expected to find "message" in the operation output, but it was not present.'
        )
    kwargs["message"] = expect_type(str, output["message"])

    return UnexpectedServerError(**kwargs)


async def _deserialize_error_validation_exception(
    http_response: HTTPResponse,
    config: Config,
    parsed_body: dict[str, DocumentValue] | None,
    default_message: str,
) -> ValidationException:
    kwargs: dict[str, Any] = {"message": default_message}

    if (parsed_body is None) and (body := await http_response.consume_body_async()):
        parsed_body = json.loads(body)

    output: dict[str, DocumentValue] = parsed_body if parsed_body is not None else {}

    if (_field_list := output.get("fieldList")) is not None:
        kwargs["field_list"] = _deserialize_validation_exception_field_list(
            _field_list, config
        )

    if "message" not in output:
        raise ServiceError(
            'Expected to find "message" in the operation output, but it was not present.'
        )
    kwargs["message"] = expect_type(str, output["message"])

    return ValidationException(**kwargs)


def _deserialize_account_list_member(
    output: DocumentValue, config: Config
) -> AccountListMember:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "accountId" not in output:
        raise ServiceError(
            'Expected to find "accountId" in the operation output, but it was not present.'
        )
    kwargs["account_id"] = expect_type(str, output["accountId"])

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_cloud_account_id := output.get("cloudAccountId")) is not None:
        kwargs["cloud_account_id"] = expect_type(str, _cloud_account_id)

    if (_data_plane_ids := output.get("dataPlaneIds")) is not None:
        kwargs["data_plane_ids"] = _deserialize_data_plane_ids(_data_plane_ids, config)

    if (_meta := output.get("meta")) is not None:
        kwargs["meta"] = _deserialize_open_properties(_meta, config)

    if (_type := output.get("type")) is not None:
        kwargs["type"] = expect_type(str, _type)

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_created_at := output.get("createdAt")) is not None:
        kwargs["created_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _created_at)
        )

    if (_updated_at := output.get("updatedAt")) is not None:
        kwargs["updated_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _updated_at)
        )

    if (_deleted_at := output.get("deletedAt")) is not None:
        kwargs["deleted_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _deleted_at)
        )

    if (_permissions := output.get("permissions")) is not None:
        kwargs["permissions"] = _deserialize_account_permissions(_permissions, config)

    return AccountListMember(**kwargs)


def _deserialize_account_permissions(
    output: DocumentValue, config: Config
) -> AccountPermissions:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "enableInventoryPolicy" not in output:
        raise ServiceError(
            'Expected to find "enableInventoryPolicy" in the operation output, but it was not present.'
        )
    kwargs["enable_inventory_policy"] = expect_type(
        bool, output["enableInventoryPolicy"]
    )

    if "enableAwsConfigPolicy" not in output:
        raise ServiceError(
            'Expected to find "enableAwsConfigPolicy" in the operation output, but it was not present.'
        )
    kwargs["enable_aws_config_policy"] = expect_type(
        bool, output["enableAwsConfigPolicy"]
    )

    if "enableDataplaneDeployPolicy" not in output:
        raise ServiceError(
            'Expected to find "enableDataplaneDeployPolicy" in the operation output, but it was not present.'
        )
    kwargs["enable_dataplane_deploy_policy"] = expect_type(
        bool, output["enableDataplaneDeployPolicy"]
    )

    if "enableDpCli" not in output:
        raise ServiceError(
            'Expected to find "enableDpCli" in the operation output, but it was not present.'
        )
    kwargs["enable_dp_cli"] = expect_type(bool, output["enableDpCli"])

    if "regions" not in output:
        raise ServiceError(
            'Expected to find "regions" in the operation output, but it was not present.'
        )
    kwargs["regions"] = _deserialize_unique_string_list(output["regions"], config)

    if (
        _add_event_bridge_permission := output.get("addEventBridgePermission")
    ) is not None:
        kwargs["add_event_bridge_permission"] = expect_type(
            bool, _add_event_bridge_permission
        )

    return AccountPermissions(**kwargs)


def _deserialize_accounts_list(
    output: DocumentValue, config: Config
) -> list[AccountListMember]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_account_list_member(e, config) for e in output]


def _deserialize_asset_list(
    output: DocumentValue, config: Config
) -> list[AssetListRecord]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_asset_list_record(e, config) for e in output]


def _deserialize_asset_list_record(
    output: DocumentValue, config: Config
) -> AssetListRecord:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "assetId" not in output:
        raise ServiceError(
            'Expected to find "assetId" in the operation output, but it was not present.'
        )
    kwargs["asset_id"] = expect_type(str, output["assetId"])

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_type := output.get("type")) is not None:
        kwargs["type"] = expect_type(str, _type)

    if (_location_type := output.get("locationType")) is not None:
        kwargs["location_type"] = expect_type(str, _location_type)

    if (_toms := output.get("toms")) is not None:
        kwargs["toms"] = _deserialize_tom_collection(_toms, config)

    if (_location := output.get("location")) is not None:
        kwargs["location"] = _deserialize_headquarter_record(_location, config)

    return AssetListRecord(**kwargs)


def _deserialize_asset_record(output: DocumentValue, config: Config) -> AssetRecord:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "assetId" not in output:
        raise ServiceError(
            'Expected to find "assetId" in the operation output, but it was not present.'
        )
    kwargs["asset_id"] = expect_type(str, output["assetId"])

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_type := output.get("type")) is not None:
        kwargs["type"] = expect_type(str, _type)

    if (_tom_ids := output.get("tomIds")) is not None:
        kwargs["tom_ids"] = _deserialize_uuid_collection(_tom_ids, config)

    if (_location_type := output.get("locationType")) is not None:
        kwargs["location_type"] = expect_type(str, _location_type)

    if (_location_id := output.get("locationId")) is not None:
        kwargs["location_id"] = expect_type(str, _location_id)

    if (_toms := output.get("toms")) is not None:
        kwargs["toms"] = _deserialize_tom_collection(_toms, config)

    if (_location := output.get("location")) is not None:
        kwargs["location"] = _deserialize_headquarter_record(_location, config)

    return AssetRecord(**kwargs)


def _deserialize_calendar_spec(output: DocumentValue, config: Config) -> CalendarSpec:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_second := output.get("second")) is not None:
        kwargs["second"] = expect_type(int, _second)

    if (_minute := output.get("minute")) is not None:
        kwargs["minute"] = expect_type(int, _minute)

    if (_hour := output.get("hour")) is not None:
        kwargs["hour"] = expect_type(int, _hour)

    if (_day_of_month := output.get("dayOfMonth")) is not None:
        kwargs["day_of_month"] = expect_type(int, _day_of_month)

    if (_month := output.get("month")) is not None:
        kwargs["month"] = expect_type(str, _month)

    if (_year := output.get("year")) is not None:
        kwargs["year"] = expect_type(int, _year)

    return CalendarSpec(**kwargs)


def _deserialize_calendar_spec_list(
    output: DocumentValue, config: Config
) -> list[CalendarSpec]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_calendar_spec(e, config) for e in output]


def _deserialize_category_list(
    output: DocumentValue, config: Config
) -> list[CategoryListMember]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_category_list_member(e, config) for e in output]


def _deserialize_category_list_member(
    output: DocumentValue, config: Config
) -> CategoryListMember:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "categoryLabel" not in output:
        raise ServiceError(
            'Expected to find "categoryLabel" in the operation output, but it was not present.'
        )
    kwargs["category_label"] = expect_type(str, output["categoryLabel"])

    if "description" not in output:
        raise ServiceError(
            'Expected to find "description" in the operation output, but it was not present.'
        )
    kwargs["description"] = expect_type(str, output["description"])

    if (_created_at := output.get("createdAt")) is not None:
        kwargs["created_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _created_at)
        )

    if (_updated_at := output.get("updatedAt")) is not None:
        kwargs["updated_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _updated_at)
        )

    return CategoryListMember(**kwargs)


def _deserialize_classification_stats(
    output: DocumentValue, config: Config
) -> dict[str, list[ClassificationStatsData]]:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found { type(output) }")

    return {
        k: _deserialize_classification_stats_list(v, config)
        for k, v in output.items()
        if v is not None
    }


def _deserialize_classification_stats_data(
    output: DocumentValue, config: Config
) -> ClassificationStatsData:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_count := output.get("count")) is not None:
        kwargs["count"] = expect_type(int, _count)

    if (_type := output.get("type")) is not None:
        kwargs["type"] = expect_type(str, _type)

    if (_classification := output.get("classification")) is not None:
        kwargs["classification"] = expect_type(str, _classification)

    return ClassificationStatsData(**kwargs)


def _deserialize_classification_stats_list(
    output: DocumentValue, config: Config
) -> list[ClassificationStatsData]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_classification_stats_data(e, config) for e in output]


def _deserialize_compliance_detail(
    output: DocumentValue, config: Config
) -> ComplianceDetail:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_compliant := output.get("compliant")) is not None:
        kwargs["compliant"] = expect_type(bool, _compliant)

    if (_infotypes := output.get("infotypes")) is not None:
        kwargs["infotypes"] = _deserialize_unique_string_list(_infotypes, config)

    return ComplianceDetail(**kwargs)


def _deserialize_compliance_detail_list(
    output: DocumentValue, config: Config
) -> list[ComplianceDetail]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_compliance_detail(e, config) for e in output]


def _deserialize_compliance_list(output: DocumentValue, config: Config) -> list[str]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [expect_type(str, e) for e in output]


def _deserialize_compliance_risk(
    output: DocumentValue, config: Config
) -> ComplianceRisk:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_infotypes := output.get("infotypes")) is not None:
        kwargs["infotypes"] = _deserialize_unique_string_list(_infotypes, config)

    if (_classifications := output.get("classifications")) is not None:
        kwargs["classifications"] = _deserialize_unique_string_list(
            _classifications, config
        )

    if (_sensitive := output.get("sensitive")) is not None:
        kwargs["sensitive"] = expect_type(bool, _sensitive)

    return ComplianceRisk(**kwargs)


def _deserialize_connector_list_member(
    output: DocumentValue, config: Config
) -> ConnectorListMember:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "connectorId" not in output:
        raise ServiceError(
            'Expected to find "connectorId" in the operation output, but it was not present.'
        )
    kwargs["connector_id"] = expect_type(str, output["connectorId"])

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_state := output.get("state")) is not None:
        kwargs["state"] = expect_type(str, _state)

    if (_data_plane_id := output.get("dataPlaneId")) is not None:
        kwargs["data_plane_id"] = expect_type(str, _data_plane_id)

    if (_resource_type := output.get("resourceType")) is not None:
        kwargs["resource_type"] = expect_type(str, _resource_type)

    if (_connector_type := output.get("connectorType")) is not None:
        kwargs["connector_type"] = expect_type(str, _connector_type)

    if (_resource_id := output.get("resourceId")) is not None:
        kwargs["resource_id"] = expect_type(str, _resource_id)

    if (_region := output.get("region")) is not None:
        kwargs["region"] = expect_type(str, _region)

    if (_created_at := output.get("createdAt")) is not None:
        kwargs["created_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _created_at)
        )

    if (_updated_at := output.get("updatedAt")) is not None:
        kwargs["updated_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _updated_at)
        )

    if (_params := output.get("params")) is not None:
        kwargs["params"] = _deserialize_open_properties(_params, config)

    if (_resource_account_id := output.get("resourceAccountId")) is not None:
        kwargs["resource_account_id"] = expect_type(str, _resource_account_id)

    if (
        _next_meta_data_sync_schedule := output.get("nextMetaDataSyncSchedule")
    ) is not None:
        kwargs["next_meta_data_sync_schedule"] = epoch_seconds_to_datetime(
            expect_type(int | float, _next_meta_data_sync_schedule)
        )

    if (_is_meta_data_sync_running := output.get("isMetaDataSyncRunning")) is not None:
        kwargs["is_meta_data_sync_running"] = expect_type(
            bool, _is_meta_data_sync_running
        )

    if (_meta_data_sync_interval := output.get("metaDataSyncInterval")) is not None:
        kwargs["meta_data_sync_interval"] = expect_type(str, _meta_data_sync_interval)

    return ConnectorListMember(**kwargs)


def _deserialize_connectors_list(
    output: DocumentValue, config: Config
) -> list[ConnectorListMember]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_connector_list_member(e, config) for e in output]


def _deserialize_country_list(output: DocumentValue, config: Config) -> list[str]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [expect_type(str, e) for e in output]


def _deserialize_data_plane_ids(output: DocumentValue, config: Config) -> list[str]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [expect_type(str, e) for e in output]


def _deserialize_data_security_event(
    output: DocumentValue, config: Config
) -> DataSecurityEvent:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_event_id := output.get("eventId")) is not None:
        kwargs["event_id"] = expect_type(str, _event_id)

    if (_issue_id := output.get("issueId")) is not None:
        kwargs["issue_id"] = expect_type(str, _issue_id)

    if (_resource_id := output.get("resourceId")) is not None:
        kwargs["resource_id"] = expect_type(str, _resource_id)

    if (_source := output.get("source")) is not None:
        kwargs["source"] = expect_type(str, _source)

    if (_type := output.get("type")) is not None:
        kwargs["type"] = expect_type(str, _type)

    if (_details := output.get("details")) is not None:
        kwargs["details"] = _deserialize_open_properties(_details, config)

    return DataSecurityEvent(**kwargs)


def _deserialize_data_security_event_list(
    output: DocumentValue, config: Config
) -> list[DataSecurityEvent]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_data_security_event(e, config) for e in output]


def _deserialize_data_subject_collection(
    output: DocumentValue, config: Config
) -> list[str]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [expect_type(str, e) for e in output]


def _deserialize_data_type(output: DocumentValue, config: Config) -> DataType:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "id" not in output:
        raise ServiceError(
            'Expected to find "id" in the operation output, but it was not present.'
        )
    kwargs["id"] = expect_type(str, output["id"])

    if "name" not in output:
        raise ServiceError(
            'Expected to find "name" in the operation output, but it was not present.'
        )
    kwargs["name"] = expect_type(str, output["name"])

    return DataType(**kwargs)


def _deserialize_data_type_collection(
    output: DocumentValue, config: Config
) -> list[DataType]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_data_type(e, config) for e in output]


def _deserialize_department_for_filter_list(
    output: DocumentValue, config: Config
) -> list[DepartmentForFilterMember]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_department_for_filter_member(e, config) for e in output]


def _deserialize_department_for_filter_member(
    output: DocumentValue, config: Config
) -> DepartmentForFilterMember:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "departmentId" not in output:
        raise ServiceError(
            'Expected to find "departmentId" in the operation output, but it was not present.'
        )
    kwargs["department_id"] = expect_type(str, output["departmentId"])

    if "name" not in output:
        raise ServiceError(
            'Expected to find "name" in the operation output, but it was not present.'
        )
    kwargs["name"] = expect_type(str, output["name"])

    return DepartmentForFilterMember(**kwargs)


def _deserialize_department_list(
    output: DocumentValue, config: Config
) -> list[DepartmentListMember]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_department_list_member(e, config) for e in output]


def _deserialize_department_list_member(
    output: DocumentValue, config: Config
) -> DepartmentListMember:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "departmentId" not in output:
        raise ServiceError(
            'Expected to find "departmentId" in the operation output, but it was not present.'
        )
    kwargs["department_id"] = expect_type(str, output["departmentId"])

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_employees := output.get("employees")) is not None:
        kwargs["employees"] = expect_type(int, _employees)

    if (_processing_activities := output.get("processingActivities")) is not None:
        kwargs["processing_activities"] = expect_type(int, _processing_activities)

    return DepartmentListMember(**kwargs)


def _deserialize_department_object(
    output: DocumentValue, config: Config
) -> DepartmentObject:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "departmentId" not in output:
        raise ServiceError(
            'Expected to find "departmentId" in the operation output, but it was not present.'
        )
    kwargs["department_id"] = expect_type(str, output["departmentId"])

    if "name" not in output:
        raise ServiceError(
            'Expected to find "name" in the operation output, but it was not present.'
        )
    kwargs["name"] = expect_type(str, output["name"])

    return DepartmentObject(**kwargs)


def _deserialize_discovered_recipient_list(
    output: DocumentValue, config: Config
) -> list[DiscoveredRecipientListMember]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_discovered_recipient_list_member(e, config) for e in output]


def _deserialize_discovered_recipient_list_member(
    output: DocumentValue, config: Config
) -> DiscoveredRecipientListMember:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "discoveredRecipientId" not in output:
        raise ServiceError(
            'Expected to find "discoveredRecipientId" in the operation output, but it was not present.'
        )
    kwargs["discovered_recipient_id"] = expect_type(
        str, output["discoveredRecipientId"]
    )

    if (_recipient_model_id := output.get("recipientModelId")) is not None:
        kwargs["recipient_model_id"] = expect_type(str, _recipient_model_id)

    if "name" not in output:
        raise ServiceError(
            'Expected to find "name" in the operation output, but it was not present.'
        )
    kwargs["name"] = expect_type(str, output["name"])

    if "discoverySource" not in output:
        raise ServiceError(
            'Expected to find "discoverySource" in the operation output, but it was not present.'
        )
    kwargs["discovery_source"] = _deserialize_discovery_source_list(
        output["discoverySource"], config
    )

    if "createdAt" not in output:
        raise ServiceError(
            'Expected to find "createdAt" in the operation output, but it was not present.'
        )
    kwargs["created_at"] = epoch_seconds_to_datetime(
        expect_type(int | float, output["createdAt"])
    )

    if "status" not in output:
        raise ServiceError(
            'Expected to find "status" in the operation output, but it was not present.'
        )
    kwargs["status"] = expect_type(str, output["status"])

    if (_user_count := output.get("userCount")) is not None:
        kwargs["user_count"] = expect_type(int, _user_count)

    return DiscoveredRecipientListMember(**kwargs)


def _deserialize_discovery_source_list(
    output: DocumentValue, config: Config
) -> list[str]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [expect_type(str, e) for e in output]


def _deserialize_domain_list(
    output: DocumentValue, config: Config
) -> list[DomainListMember]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_domain_list_member(e, config) for e in output]


def _deserialize_domain_list_member(
    output: DocumentValue, config: Config
) -> DomainListMember:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "domainId" not in output:
        raise ServiceError(
            'Expected to find "domainId" in the operation output, but it was not present.'
        )
    kwargs["domain_id"] = expect_type(str, output["domainId"])

    if "name" not in output:
        raise ServiceError(
            'Expected to find "name" in the operation output, but it was not present.'
        )
    kwargs["name"] = expect_type(str, output["name"])

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if "frequency" not in output:
        raise ServiceError(
            'Expected to find "frequency" in the operation output, but it was not present.'
        )
    kwargs["frequency"] = expect_type(str, output["frequency"])

    if "createdAt" not in output:
        raise ServiceError(
            'Expected to find "createdAt" in the operation output, but it was not present.'
        )
    kwargs["created_at"] = epoch_seconds_to_datetime(
        expect_type(int | float, output["createdAt"])
    )

    if (_updated_at := output.get("updatedAt")) is not None:
        kwargs["updated_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _updated_at)
        )

    if (_recipients := output.get("recipients")) is not None:
        kwargs["recipients"] = _deserialize_recipients_discovered_of_domain_list(
            _recipients, config
        )

    return DomainListMember(**kwargs)


def _deserialize_dpia_availability_risk(
    output: DocumentValue, config: Config
) -> DpiaAvailabilityRisk:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_threats := output.get("threats")) is not None:
        kwargs["threats"] = _deserialize_dpia_availability_risk_threats_collection(
            _threats, config
        )

    if (_threats_comment := output.get("threatsComment")) is not None:
        kwargs["threats_comment"] = expect_type(str, _threats_comment)

    if (_impacts := output.get("impacts")) is not None:
        kwargs["impacts"] = _deserialize_dpia_availability_risk_impacts_collection(
            _impacts, config
        )

    if (_impacts_comment := output.get("impactsComment")) is not None:
        kwargs["impacts_comment"] = expect_type(str, _impacts_comment)

    if (_risk_sources := output.get("riskSources")) is not None:
        kwargs["risk_sources"] = _deserialize_dpia_risk_risk_sources_collection(
            _risk_sources, config
        )

    if (_risk_sources_comment := output.get("riskSourcesComment")) is not None:
        kwargs["risk_sources_comment"] = expect_type(str, _risk_sources_comment)

    if (_implemented_toms := output.get("implementedToms")) is not None:
        kwargs["implemented_toms"] = _deserialize_uuid_collection(
            _implemented_toms, config
        )

    if (_implemented_toms_comment := output.get("implementedTomsComment")) is not None:
        kwargs["implemented_toms_comment"] = expect_type(str, _implemented_toms_comment)

    if (_planned_toms := output.get("plannedToms")) is not None:
        kwargs["planned_toms"] = _deserialize_uuid_collection(_planned_toms, config)

    if (_planned_toms_comment := output.get("plannedTomsComment")) is not None:
        kwargs["planned_toms_comment"] = expect_type(str, _planned_toms_comment)

    if (_baseline_severity := output.get("baselineSeverity")) is not None:
        kwargs["baseline_severity"] = expect_type(str, _baseline_severity)

    if (_baseline_likelihood := output.get("baselineLikelihood")) is not None:
        kwargs["baseline_likelihood"] = expect_type(str, _baseline_likelihood)

    if (_baseline_comment := output.get("baselineComment")) is not None:
        kwargs["baseline_comment"] = expect_type(str, _baseline_comment)

    if (_residual_risk_severity := output.get("residualRiskSeverity")) is not None:
        kwargs["residual_risk_severity"] = expect_type(str, _residual_risk_severity)

    if (_residual_risk_likelihood := output.get("residualRiskLikelihood")) is not None:
        kwargs["residual_risk_likelihood"] = expect_type(str, _residual_risk_likelihood)

    if (_residual_risk_comment := output.get("residualRiskComment")) is not None:
        kwargs["residual_risk_comment"] = expect_type(str, _residual_risk_comment)

    return DpiaAvailabilityRisk(**kwargs)


def _deserialize_dpia_availability_risk_impact(
    output: DocumentValue, config: Config
) -> DpiaAvailabilityRiskImpact:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "id" not in output:
        raise ServiceError(
            'Expected to find "id" in the operation output, but it was not present.'
        )
    kwargs["id"] = expect_type(str, output["id"])

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    return DpiaAvailabilityRiskImpact(**kwargs)


def _deserialize_dpia_availability_risk_impacts_collection(
    output: DocumentValue, config: Config
) -> list[DpiaAvailabilityRiskImpact]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_dpia_availability_risk_impact(e, config) for e in output]


def _deserialize_dpia_availability_risk_threat(
    output: DocumentValue, config: Config
) -> DpiaAvailabilityRiskThreat:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "id" not in output:
        raise ServiceError(
            'Expected to find "id" in the operation output, but it was not present.'
        )
    kwargs["id"] = expect_type(str, output["id"])

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    return DpiaAvailabilityRiskThreat(**kwargs)


def _deserialize_dpia_availability_risk_threats_collection(
    output: DocumentValue, config: Config
) -> list[DpiaAvailabilityRiskThreat]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_dpia_availability_risk_threat(e, config) for e in output]


def _deserialize_dpia_confidentiality_risk(
    output: DocumentValue, config: Config
) -> DpiaConfidentialityRisk:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_threats := output.get("threats")) is not None:
        kwargs["threats"] = _deserialize_dpia_confidentiality_risk_threats_collection(
            _threats, config
        )

    if (_threats_comment := output.get("threatsComment")) is not None:
        kwargs["threats_comment"] = expect_type(str, _threats_comment)

    if (_impacts := output.get("impacts")) is not None:
        kwargs["impacts"] = _deserialize_dpia_confidentiality_risk_impacts_collection(
            _impacts, config
        )

    if (_impacts_comment := output.get("impactsComment")) is not None:
        kwargs["impacts_comment"] = expect_type(str, _impacts_comment)

    if (_risk_sources := output.get("riskSources")) is not None:
        kwargs["risk_sources"] = _deserialize_dpia_risk_risk_sources_collection(
            _risk_sources, config
        )

    if (_risk_sources_comment := output.get("riskSourcesComment")) is not None:
        kwargs["risk_sources_comment"] = expect_type(str, _risk_sources_comment)

    if (_implemented_toms := output.get("implementedToms")) is not None:
        kwargs["implemented_toms"] = _deserialize_uuid_collection(
            _implemented_toms, config
        )

    if (_implemented_toms_comment := output.get("implementedTomsComment")) is not None:
        kwargs["implemented_toms_comment"] = expect_type(str, _implemented_toms_comment)

    if (_planned_toms := output.get("plannedToms")) is not None:
        kwargs["planned_toms"] = _deserialize_uuid_collection(_planned_toms, config)

    if (_planned_toms_comment := output.get("plannedTomsComment")) is not None:
        kwargs["planned_toms_comment"] = expect_type(str, _planned_toms_comment)

    if (_baseline_severity := output.get("baselineSeverity")) is not None:
        kwargs["baseline_severity"] = expect_type(str, _baseline_severity)

    if (_baseline_likelihood := output.get("baselineLikelihood")) is not None:
        kwargs["baseline_likelihood"] = expect_type(str, _baseline_likelihood)

    if (_baseline_comment := output.get("baselineComment")) is not None:
        kwargs["baseline_comment"] = expect_type(str, _baseline_comment)

    if (_residual_risk_severity := output.get("residualRiskSeverity")) is not None:
        kwargs["residual_risk_severity"] = expect_type(str, _residual_risk_severity)

    if (_residual_risk_likelihood := output.get("residualRiskLikelihood")) is not None:
        kwargs["residual_risk_likelihood"] = expect_type(str, _residual_risk_likelihood)

    if (_residual_risk_comment := output.get("residualRiskComment")) is not None:
        kwargs["residual_risk_comment"] = expect_type(str, _residual_risk_comment)

    return DpiaConfidentialityRisk(**kwargs)


def _deserialize_dpia_confidentiality_risk_impact(
    output: DocumentValue, config: Config
) -> DpiaConfidentialityRiskImpact:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "id" not in output:
        raise ServiceError(
            'Expected to find "id" in the operation output, but it was not present.'
        )
    kwargs["id"] = expect_type(str, output["id"])

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    return DpiaConfidentialityRiskImpact(**kwargs)


def _deserialize_dpia_confidentiality_risk_impacts_collection(
    output: DocumentValue, config: Config
) -> list[DpiaConfidentialityRiskImpact]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_dpia_confidentiality_risk_impact(e, config) for e in output]


def _deserialize_dpia_confidentiality_risk_threat(
    output: DocumentValue, config: Config
) -> DpiaConfidentialityRiskThreat:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "id" not in output:
        raise ServiceError(
            'Expected to find "id" in the operation output, but it was not present.'
        )
    kwargs["id"] = expect_type(str, output["id"])

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    return DpiaConfidentialityRiskThreat(**kwargs)


def _deserialize_dpia_confidentiality_risk_threats_collection(
    output: DocumentValue, config: Config
) -> list[DpiaConfidentialityRiskThreat]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_dpia_confidentiality_risk_threat(e, config) for e in output]


def _deserialize_dpia_integrity_risk(
    output: DocumentValue, config: Config
) -> DpiaIntegrityRisk:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_threats := output.get("threats")) is not None:
        kwargs["threats"] = _deserialize_dpia_integrity_risk_threats_collection(
            _threats, config
        )

    if (_threats_comment := output.get("threatsComment")) is not None:
        kwargs["threats_comment"] = expect_type(str, _threats_comment)

    if (_impacts := output.get("impacts")) is not None:
        kwargs["impacts"] = _deserialize_dpia_integrity_risk_impacts_collection(
            _impacts, config
        )

    if (_impacts_comment := output.get("impactsComment")) is not None:
        kwargs["impacts_comment"] = expect_type(str, _impacts_comment)

    if (_risk_sources := output.get("riskSources")) is not None:
        kwargs["risk_sources"] = _deserialize_dpia_risk_risk_sources_collection(
            _risk_sources, config
        )

    if (_risk_sources_comment := output.get("riskSourcesComment")) is not None:
        kwargs["risk_sources_comment"] = expect_type(str, _risk_sources_comment)

    if (_implemented_toms := output.get("implementedToms")) is not None:
        kwargs["implemented_toms"] = _deserialize_uuid_collection(
            _implemented_toms, config
        )

    if (_implemented_toms_comment := output.get("implementedTomsComment")) is not None:
        kwargs["implemented_toms_comment"] = expect_type(str, _implemented_toms_comment)

    if (_planned_toms := output.get("plannedToms")) is not None:
        kwargs["planned_toms"] = _deserialize_uuid_collection(_planned_toms, config)

    if (_planned_toms_comment := output.get("plannedTomsComment")) is not None:
        kwargs["planned_toms_comment"] = expect_type(str, _planned_toms_comment)

    if (_baseline_severity := output.get("baselineSeverity")) is not None:
        kwargs["baseline_severity"] = expect_type(str, _baseline_severity)

    if (_baseline_likelihood := output.get("baselineLikelihood")) is not None:
        kwargs["baseline_likelihood"] = expect_type(str, _baseline_likelihood)

    if (_baseline_comment := output.get("baselineComment")) is not None:
        kwargs["baseline_comment"] = expect_type(str, _baseline_comment)

    if (_residual_risk_severity := output.get("residualRiskSeverity")) is not None:
        kwargs["residual_risk_severity"] = expect_type(str, _residual_risk_severity)

    if (_residual_risk_likelihood := output.get("residualRiskLikelihood")) is not None:
        kwargs["residual_risk_likelihood"] = expect_type(str, _residual_risk_likelihood)

    if (_residual_risk_comment := output.get("residualRiskComment")) is not None:
        kwargs["residual_risk_comment"] = expect_type(str, _residual_risk_comment)

    return DpiaIntegrityRisk(**kwargs)


def _deserialize_dpia_integrity_risk_impact(
    output: DocumentValue, config: Config
) -> DpiaIntegrityRiskImpact:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "id" not in output:
        raise ServiceError(
            'Expected to find "id" in the operation output, but it was not present.'
        )
    kwargs["id"] = expect_type(str, output["id"])

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    return DpiaIntegrityRiskImpact(**kwargs)


def _deserialize_dpia_integrity_risk_impacts_collection(
    output: DocumentValue, config: Config
) -> list[DpiaIntegrityRiskImpact]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_dpia_integrity_risk_impact(e, config) for e in output]


def _deserialize_dpia_integrity_risk_threat(
    output: DocumentValue, config: Config
) -> DpiaIntegrityRiskThreat:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "id" not in output:
        raise ServiceError(
            'Expected to find "id" in the operation output, but it was not present.'
        )
    kwargs["id"] = expect_type(str, output["id"])

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    return DpiaIntegrityRiskThreat(**kwargs)


def _deserialize_dpia_integrity_risk_threats_collection(
    output: DocumentValue, config: Config
) -> list[DpiaIntegrityRiskThreat]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_dpia_integrity_risk_threat(e, config) for e in output]


def _deserialize_dpia_privacy_framework(
    output: DocumentValue, config: Config
) -> DpiaPrivacyFramework:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_purpose_limitation := output.get("purposeLimitation")) is not None:
        kwargs["purpose_limitation"] = expect_type(str, _purpose_limitation)

    if (_data_minimisation := output.get("dataMinimisation")) is not None:
        kwargs["data_minimisation"] = expect_type(str, _data_minimisation)

    if (_accuracy := output.get("accuracy")) is not None:
        kwargs["accuracy"] = expect_type(str, _accuracy)

    if (_retention := output.get("retention")) is not None:
        kwargs["retention"] = expect_type(bool, _retention)

    if (_retention_comment := output.get("retentionComment")) is not None:
        kwargs["retention_comment"] = expect_type(str, _retention_comment)

    if (_transparency := output.get("transparency")) is not None:
        kwargs["transparency"] = expect_type(str, _transparency)

    if (_consent := output.get("consent")) is not None:
        kwargs["consent"] = expect_type(str, _consent)

    if (_data_rights_exercised := output.get("dataRightsExercised")) is not None:
        kwargs["data_rights_exercised"] = expect_type(str, _data_rights_exercised)

    if (_additional_comment := output.get("additionalComment")) is not None:
        kwargs["additional_comment"] = expect_type(str, _additional_comment)

    return DpiaPrivacyFramework(**kwargs)


def _deserialize_dpia_risk_risk_source(
    output: DocumentValue, config: Config
) -> DpiaRiskRiskSource:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "id" not in output:
        raise ServiceError(
            'Expected to find "id" in the operation output, but it was not present.'
        )
    kwargs["id"] = expect_type(str, output["id"])

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    return DpiaRiskRiskSource(**kwargs)


def _deserialize_dpia_risk_risk_sources_collection(
    output: DocumentValue, config: Config
) -> list[DpiaRiskRiskSource]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_dpia_risk_risk_source(e, config) for e in output]


def _deserialize_employee_for_filter_member(
    output: DocumentValue, config: Config
) -> EmployeeForFilterMember:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "employeeId" not in output:
        raise ServiceError(
            'Expected to find "employeeId" in the operation output, but it was not present.'
        )
    kwargs["employee_id"] = expect_type(str, output["employeeId"])

    if "name" not in output:
        raise ServiceError(
            'Expected to find "name" in the operation output, but it was not present.'
        )
    kwargs["name"] = expect_type(str, output["name"])

    return EmployeeForFilterMember(**kwargs)


def _deserialize_employee_list(
    output: DocumentValue, config: Config
) -> list[EmployeeListMember]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_employee_list_member(e, config) for e in output]


def _deserialize_employee_list_member(
    output: DocumentValue, config: Config
) -> EmployeeListMember:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "employeeId" not in output:
        raise ServiceError(
            'Expected to find "employeeId" in the operation output, but it was not present.'
        )
    kwargs["employee_id"] = expect_type(str, output["employeeId"])

    if "name" not in output:
        raise ServiceError(
            'Expected to find "name" in the operation output, but it was not present.'
        )
    kwargs["name"] = expect_type(str, output["name"])

    if "surname" not in output:
        raise ServiceError(
            'Expected to find "surname" in the operation output, but it was not present.'
        )
    kwargs["surname"] = expect_type(str, output["surname"])

    if (_position := output.get("position")) is not None:
        kwargs["position"] = expect_type(str, _position)

    if (_nif := output.get("nif")) is not None:
        kwargs["nif"] = expect_type(str, _nif)

    if (_start_date := output.get("startDate")) is not None:
        kwargs["start_date"] = expect_type(str, _start_date)

    if (_end_date := output.get("endDate")) is not None:
        kwargs["end_date"] = expect_type(str, _end_date)

    if "createdBy" not in output:
        raise ServiceError(
            'Expected to find "createdBy" in the operation output, but it was not present.'
        )
    kwargs["created_by"] = expect_type(str, output["createdBy"])

    if (_email := output.get("email")) is not None:
        kwargs["email"] = expect_type(str, _email)

    if (_manager := output.get("manager")) is not None:
        kwargs["manager"] = expect_type(str, _manager)

    if (_department := output.get("department")) is not None:
        kwargs["department"] = expect_type(str, _department)

    if (_reference_id := output.get("referenceId")) is not None:
        kwargs["reference_id"] = expect_type(str, _reference_id)

    if (_department_object := output.get("departmentObject")) is not None:
        kwargs["department_object"] = _deserialize_department_object(
            _department_object, config
        )

    if (_manager_object := output.get("managerObject")) is not None:
        kwargs["manager_object"] = _deserialize_manager_object(_manager_object, config)

    if (_processing_activities := output.get("processingActivities")) is not None:
        kwargs["processing_activities"] = expect_type(int, _processing_activities)

    return EmployeeListMember(**kwargs)


def _deserialize_employees_for_filter_list(
    output: DocumentValue, config: Config
) -> list[EmployeeForFilterMember]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_employee_for_filter_member(e, config) for e in output]


def _deserialize_events(output: DocumentValue, config: Config) -> Events:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_event_id := output.get("eventId")) is not None:
        kwargs["event_id"] = expect_type(str, _event_id)

    if (_issue_id := output.get("issueId")) is not None:
        kwargs["issue_id"] = expect_type(str, _issue_id)

    if (_resource_id := output.get("resourceId")) is not None:
        kwargs["resource_id"] = expect_type(str, _resource_id)

    if (_source := output.get("source")) is not None:
        kwargs["source"] = expect_type(str, _source)

    if (_type := output.get("type")) is not None:
        kwargs["type"] = expect_type(str, _type)

    if (_details := output.get("details")) is not None:
        kwargs["details"] = Document(_details)

    if (_created_at := output.get("createdAt")) is not None:
        kwargs["created_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _created_at)
        )

    if (_resource_name := output.get("resourceName")) is not None:
        kwargs["resource_name"] = expect_type(str, _resource_name)

    if (_scan_id := output.get("scanId")) is not None:
        kwargs["scan_id"] = expect_type(str, _scan_id)

    if (_snapshot := output.get("snapshot")) is not None:
        kwargs["snapshot"] = _deserialize_inspection_result_snapshot(_snapshot, config)

    if (_tokens := output.get("tokens")) is not None:
        kwargs["tokens"] = _deserialize_tokens(_tokens, config)

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_scan_iteration_id := output.get("scanIterationId")) is not None:
        kwargs["scan_iteration_id"] = expect_type(str, _scan_iteration_id)

    if (_scan_execution_id := output.get("scanExecutionId")) is not None:
        kwargs["scan_execution_id"] = expect_type(str, _scan_execution_id)

    if (_meta := output.get("meta")) is not None:
        kwargs["meta"] = Document(_meta)

    if (
        _page_inspection_insight_id := output.get("pageInspectionInsightId")
    ) is not None:
        kwargs["page_inspection_insight_id"] = expect_type(
            str, _page_inspection_insight_id
        )

    if (_resource_type := output.get("resourceType")) is not None:
        kwargs["resource_type"] = expect_type(str, _resource_type)

    if (_user_id := output.get("userId")) is not None:
        kwargs["user_id"] = expect_type(str, _user_id)

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_email := output.get("email")) is not None:
        kwargs["email"] = expect_type(str, _email)

    if (_connector_user_id := output.get("connectorUserId")) is not None:
        kwargs["connector_user_id"] = expect_type(str, _connector_user_id)

    if (_connector_username := output.get("connectorUsername")) is not None:
        kwargs["connector_username"] = expect_type(str, _connector_username)

    if (_external := output.get("external")) is not None:
        kwargs["external"] = expect_type(bool, _external)

    return Events(**kwargs)


def _deserialize_events_list(output: DocumentValue, config: Config) -> list[Events]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_events(e, config) for e in output]


def _deserialize_exported_data_url(
    output: DocumentValue, config: Config
) -> ExportedDataUrl:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_url := output.get("url")) is not None:
        kwargs["url"] = expect_type(str, _url)

    if (_type := output.get("type")) is not None:
        kwargs["type"] = expect_type(str, _type)

    return ExportedDataUrl(**kwargs)


def _deserialize_headquarter_list(
    output: DocumentValue, config: Config
) -> list[HeadquarterListRecord]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_headquarter_list_record(e, config) for e in output]


def _deserialize_headquarter_list_record(
    output: DocumentValue, config: Config
) -> HeadquarterListRecord:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "headquarterId" not in output:
        raise ServiceError(
            'Expected to find "headquarterId" in the operation output, but it was not present.'
        )
    kwargs["headquarter_id"] = expect_type(str, output["headquarterId"])

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_city := output.get("city")) is not None:
        kwargs["city"] = expect_type(str, _city)

    if (_address := output.get("address")) is not None:
        kwargs["address"] = expect_type(str, _address)

    if (_country := output.get("country")) is not None:
        kwargs["country"] = expect_type(str, _country)

    if (_zipcode := output.get("zipcode")) is not None:
        kwargs["zipcode"] = expect_type(str, _zipcode)

    if (_toms := output.get("toms")) is not None:
        kwargs["toms"] = _deserialize_tom_collection(_toms, config)

    return HeadquarterListRecord(**kwargs)


def _deserialize_headquarter_record(
    output: DocumentValue, config: Config
) -> HeadquarterRecord:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "headquarterId" not in output:
        raise ServiceError(
            'Expected to find "headquarterId" in the operation output, but it was not present.'
        )
    kwargs["headquarter_id"] = expect_type(str, output["headquarterId"])

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_city := output.get("city")) is not None:
        kwargs["city"] = expect_type(str, _city)

    if (_address := output.get("address")) is not None:
        kwargs["address"] = expect_type(str, _address)

    if (_country := output.get("country")) is not None:
        kwargs["country"] = expect_type(str, _country)

    if (_zipcode := output.get("zipcode")) is not None:
        kwargs["zipcode"] = expect_type(str, _zipcode)

    if (_toms := output.get("toms")) is not None:
        kwargs["toms"] = _deserialize_tom_collection(_toms, config)

    return HeadquarterRecord(**kwargs)


def _deserialize_infotype_category_list(
    output: DocumentValue, config: Config
) -> list[str]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [expect_type(str, e) for e in output]


def _deserialize_info_types_combination_filter(
    output: DocumentValue, config: Config
) -> InfoTypesCombinationFilter:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "infoTypes" not in output:
        raise ServiceError(
            'Expected to find "infoTypes" in the operation output, but it was not present.'
        )
    kwargs["info_types"] = _deserialize_unique_string_list(output["infoTypes"], config)

    if "ops" not in output:
        raise ServiceError(
            'Expected to find "ops" in the operation output, but it was not present.'
        )
    kwargs["ops"] = expect_type(str, output["ops"])

    return InfoTypesCombinationFilter(**kwargs)


def _deserialize_infotypes_list(output: DocumentValue, config: Config) -> list[str]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [expect_type(str, e) for e in output]


def _deserialize_infotype_snapshot(
    output: DocumentValue, config: Config
) -> InfotypeSnapshot:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "found" not in output:
        raise ServiceError(
            'Expected to find "found" in the operation output, but it was not present.'
        )
    kwargs["found"] = expect_type(bool, output["found"])

    if (_count := output.get("count")) is not None:
        kwargs["count"] = expect_type(int, _count)

    return InfotypeSnapshot(**kwargs)


def _deserialize_insights_filter_value_parameter_list(
    output: DocumentValue, config: Config
) -> list[ListInsightsFilterValueParameter]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [
        _deserialize_list_insights_filter_value_parameter(e, config) for e in output
    ]


def _deserialize_inspection_policy(
    output: DocumentValue, config: Config
) -> InspectionPolicy:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_collect_tokens := output.get("collectTokens")) is not None:
        kwargs["collect_tokens"] = expect_type(bool, _collect_tokens)

    if (_mask_details := output.get("maskDetails")) is not None:
        kwargs["mask_details"] = expect_type(bool, _mask_details)

    if (_infotypes := output.get("infotypes")) is not None:
        kwargs["infotypes"] = _deserialize_infotypes_list(_infotypes, config)

    if (_compliance := output.get("compliance")) is not None:
        kwargs["compliance"] = _deserialize_compliance_list(_compliance, config)

    return InspectionPolicy(**kwargs)


def _deserialize_inspection_result_list(
    output: DocumentValue, config: Config
) -> list[InspectionResultRecord]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_inspection_result_record(e, config) for e in output]


def _deserialize_inspection_result_record(
    output: DocumentValue, config: Config
) -> InspectionResultRecord:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "id" not in output:
        raise ServiceError(
            'Expected to find "id" in the operation output, but it was not present.'
        )
    kwargs["id"] = expect_type(str, output["id"])

    if (_scan_id := output.get("scanId")) is not None:
        kwargs["scan_id"] = expect_type(str, _scan_id)

    if (_scan_iteration_id := output.get("scanIterationId")) is not None:
        kwargs["scan_iteration_id"] = expect_type(str, _scan_iteration_id)

    if (_resource_id := output.get("resourceId")) is not None:
        kwargs["resource_id"] = expect_type(str, _resource_id)

    if (_resource_name := output.get("resourceName")) is not None:
        kwargs["resource_name"] = expect_type(str, _resource_name)

    if (_resource_type := output.get("resourceType")) is not None:
        kwargs["resource_type"] = expect_type(str, _resource_type)

    if (_file_name := output.get("fileName")) is not None:
        kwargs["file_name"] = expect_type(str, _file_name)

    if (_snapshot := output.get("snapshot")) is not None:
        kwargs["snapshot"] = _deserialize_inspection_result_snapshot(_snapshot, config)

    if (_compliance := output.get("compliance")) is not None:
        kwargs["compliance"] = _deserialize_compliance_detail_list(_compliance, config)

    if (_parent_id := output.get("parentId")) is not None:
        kwargs["parent_id"] = expect_type(str, _parent_id)

    if (_meta := output.get("meta")) is not None:
        kwargs["meta"] = _deserialize_open_properties(_meta, config)

    if (_stats := output.get("stats")) is not None:
        kwargs["stats"] = _deserialize_record_type(_stats, config)

    if (_tokens := output.get("tokens")) is not None:
        kwargs["tokens"] = _deserialize_tokens(_tokens, config)

    if (_sample_tokens := output.get("sampleTokens")) is not None:
        kwargs["sample_tokens"] = _deserialize_tokens(_sample_tokens, config)

    if (_scan_parameters := output.get("scanParameters")) is not None:
        kwargs["scan_parameters"] = _deserialize_scan_parameters(
            _scan_parameters, config
        )

    if (_created_at := output.get("createdAt")) is not None:
        kwargs["created_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _created_at)
        )

    if (_updated_at := output.get("updatedAt")) is not None:
        kwargs["updated_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _updated_at)
        )

    if (_has_finding := output.get("hasFinding")) is not None:
        kwargs["has_finding"] = expect_type(bool, _has_finding)

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_user_name := output.get("userName")) is not None:
        kwargs["user_name"] = expect_type(str, _user_name)

    if (_user_email := output.get("userEmail")) is not None:
        kwargs["user_email"] = expect_type(str, _user_email)

    return InspectionResultRecord(**kwargs)


def _deserialize_inspection_result_snapshot(
    output: DocumentValue, config: Config
) -> dict[str, InfotypeSnapshot]:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found { type(output) }")

    return {
        k: _deserialize_infotype_snapshot(v, config)
        for k, v in output.items()
        if v is not None
    }


def _deserialize_issue_list(output: DocumentValue, config: Config) -> list[IssueRecord]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_issue_record(e, config) for e in output]


def _deserialize_issue_notification(
    output: DocumentValue, config: Config
) -> IssueNotification:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_success := output.get("success")) is not None:
        kwargs["success"] = expect_type(bool, _success)

    if (_type := output.get("type")) is not None:
        kwargs["type"] = expect_type(str, _type)

    if (_link := output.get("link")) is not None:
        kwargs["link"] = expect_type(str, _link)

    if (_time := output.get("time")) is not None:
        kwargs["time"] = expect_type(str, _time)

    return IssueNotification(**kwargs)


def _deserialize_issue_notification_list(
    output: DocumentValue, config: Config
) -> list[IssueNotification]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_issue_notification(e, config) for e in output]


def _deserialize_issue_record(output: DocumentValue, config: Config) -> IssueRecord:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "issueId" not in output:
        raise ServiceError(
            'Expected to find "issueId" in the operation output, but it was not present.'
        )
    kwargs["issue_id"] = expect_type(str, output["issueId"])

    if (_resource_id := output.get("resourceId")) is not None:
        kwargs["resource_id"] = expect_type(str, _resource_id)

    if (_state := output.get("state")) is not None:
        kwargs["state"] = expect_type(str, _state)

    if (_severity := output.get("severity")) is not None:
        kwargs["severity"] = expect_type(str, _severity)

    if (_resource := output.get("resource")) is not None:
        kwargs["resource"] = _deserialize_issue_resource_details(_resource, config)

    if (_security_risk := output.get("securityRisk")) is not None:
        kwargs["security_risk"] = _deserialize_security_risk(_security_risk, config)

    if (_compliance_risk := output.get("complianceRisk")) is not None:
        kwargs["compliance_risk"] = _deserialize_compliance_risk(
            _compliance_risk, config
        )

    if (_events := output.get("events")) is not None:
        kwargs["events"] = _deserialize_data_security_event_list(_events, config)

    if (_notifications := output.get("notifications")) is not None:
        kwargs["notifications"] = _deserialize_issue_notification_list(
            _notifications, config
        )

    if (_created_at := output.get("createdAt")) is not None:
        kwargs["created_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _created_at)
        )

    if (_updated_at := output.get("updatedAt")) is not None:
        kwargs["updated_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _updated_at)
        )

    return IssueRecord(**kwargs)


def _deserialize_issue_resource_details(
    output: DocumentValue, config: Config
) -> IssueResourceDetails:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_type := output.get("type")) is not None:
        kwargs["type"] = expect_type(str, _type)

    if (_snapshot := output.get("snapshot")) is not None:
        kwargs["snapshot"] = _deserialize_inspection_result_snapshot(_snapshot, config)

    if (_compliance := output.get("compliance")) is not None:
        kwargs["compliance"] = _deserialize_compliance_detail_list(_compliance, config)

    if (_owner := output.get("owner")) is not None:
        kwargs["owner"] = _deserialize_owner_object_list(_owner, config)

    if (_meta := output.get("meta")) is not None:
        kwargs["meta"] = _deserialize_open_properties(_meta, config)

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_aka := output.get("aka")) is not None:
        kwargs["aka"] = expect_type(str, _aka)

    if (_properties := output.get("properties")) is not None:
        kwargs["properties"] = _deserialize_open_properties(_properties, config)

    return IssueResourceDetails(**kwargs)


def _deserialize_lawful_basis(output: DocumentValue, config: Config) -> LawfulBasis:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "lawfulnessType" not in output:
        raise ServiceError(
            'Expected to find "lawfulnessType" in the operation output, but it was not present.'
        )
    kwargs["lawfulness_type"] = expect_type(str, output["lawfulnessType"])

    if (_comment := output.get("comment")) is not None:
        kwargs["comment"] = expect_type(str, _comment)

    return LawfulBasis(**kwargs)


def _deserialize_lawful_basis_collection(
    output: DocumentValue, config: Config
) -> list[LawfulBasis]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_lawful_basis(e, config) for e in output]


def _deserialize_leaf_resources_data_list(
    output: DocumentValue, config: Config
) -> list[LeafResourcesDataRecordMember]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_leaf_resources_data_record_member(e, config) for e in output]


def _deserialize_leaf_resources_data_record_member(
    output: DocumentValue, config: Config
) -> LeafResourcesDataRecordMember:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "resourceId" not in output:
        raise ServiceError(
            'Expected to find "resourceId" in the operation output, but it was not present.'
        )
    kwargs["resource_id"] = expect_type(str, output["resourceId"])

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_parent_id := output.get("parentId")) is not None:
        kwargs["parent_id"] = expect_type(str, _parent_id)

    if (_type := output.get("type")) is not None:
        kwargs["type"] = expect_type(str, _type)

    if (_meta := output.get("meta")) is not None:
        kwargs["meta"] = _deserialize_open_properties(_meta, config)

    if (_snapshot := output.get("snapshot")) is not None:
        kwargs["snapshot"] = _deserialize_inspection_result_snapshot(_snapshot, config)

    if (_compliance := output.get("compliance")) is not None:
        kwargs["compliance"] = _deserialize_compliance_detail_list(_compliance, config)

    if (_owner := output.get("owner")) is not None:
        kwargs["owner"] = _deserialize_owner_object_list(_owner, config)

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_last_scanned := output.get("lastScanned")) is not None:
        kwargs["last_scanned"] = epoch_seconds_to_datetime(
            expect_type(int | float, _last_scanned)
        )

    return LeafResourcesDataRecordMember(**kwargs)


def _deserialize_list_insights_filter_value_parameter(
    output: DocumentValue, config: Config
) -> ListInsightsFilterValueParameter:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_id := output.get("id")) is not None:
        kwargs["id"] = expect_type(str, _id)

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    return ListInsightsFilterValueParameter(**kwargs)


def _deserialize_list_processing_activity_filter_member(
    output: DocumentValue, config: Config
) -> ListProcessingActivityFilterMember:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_id := output.get("id")) is not None:
        kwargs["id"] = expect_type(str, _id)

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    return ListProcessingActivityFilterMember(**kwargs)


def _deserialize_log_member(output: DocumentValue, config: Config) -> LogMember:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_time := output.get("time")) is not None:
        kwargs["time"] = expect_type(str, _time)

    if (_email := output.get("email")) is not None:
        kwargs["email"] = expect_type(str, _email)

    if (_request_id := output.get("requestId")) is not None:
        kwargs["request_id"] = expect_type(str, _request_id)

    if (_roles := output.get("roles")) is not None:
        kwargs["roles"] = _deserialize_unique_string_list(_roles, config)

    if (_operation := output.get("operation")) is not None:
        kwargs["operation"] = expect_type(str, _operation)

    if (_msg := output.get("msg")) is not None:
        kwargs["msg"] = expect_type(str, _msg)

    return LogMember(**kwargs)


def _deserialize_logs_results(output: DocumentValue, config: Config) -> list[LogMember]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_log_member(e, config) for e in output]


def _deserialize_management_method(
    output: DocumentValue, config: Config
) -> ManagementMethod:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "methodType" not in output:
        raise ServiceError(
            'Expected to find "methodType" in the operation output, but it was not present.'
        )
    kwargs["method_type"] = expect_type(str, output["methodType"])

    if (_email := output.get("email")) is not None:
        kwargs["email"] = expect_type(str, _email)

    if (_postal_address := output.get("postalAddress")) is not None:
        kwargs["postal_address"] = _deserialize_postal_address(_postal_address, config)

    return ManagementMethod(**kwargs)


def _deserialize_management_method_collection(
    output: DocumentValue, config: Config
) -> list[ManagementMethod]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_management_method(e, config) for e in output]


def _deserialize_manager_object(output: DocumentValue, config: Config) -> ManagerObject:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "employeeId" not in output:
        raise ServiceError(
            'Expected to find "employeeId" in the operation output, but it was not present.'
        )
    kwargs["employee_id"] = expect_type(str, output["employeeId"])

    if "name" not in output:
        raise ServiceError(
            'Expected to find "name" in the operation output, but it was not present.'
        )
    kwargs["name"] = expect_type(str, output["name"])

    if "surname" not in output:
        raise ServiceError(
            'Expected to find "surname" in the operation output, but it was not present.'
        )
    kwargs["surname"] = expect_type(str, output["surname"])

    if (_position := output.get("position")) is not None:
        kwargs["position"] = expect_type(str, _position)

    if (_nif := output.get("nif")) is not None:
        kwargs["nif"] = expect_type(str, _nif)

    if (_start_date := output.get("startDate")) is not None:
        kwargs["start_date"] = expect_type(str, _start_date)

    if (_end_date := output.get("endDate")) is not None:
        kwargs["end_date"] = expect_type(str, _end_date)

    if "createdBy" not in output:
        raise ServiceError(
            'Expected to find "createdBy" in the operation output, but it was not present.'
        )
    kwargs["created_by"] = expect_type(str, output["createdBy"])

    if (_email := output.get("email")) is not None:
        kwargs["email"] = expect_type(str, _email)

    if (_manager := output.get("manager")) is not None:
        kwargs["manager"] = expect_type(str, _manager)

    if (_department := output.get("department")) is not None:
        kwargs["department"] = expect_type(str, _department)

    if (_reference_id := output.get("referenceId")) is not None:
        kwargs["reference_id"] = expect_type(str, _reference_id)

    if (_department_object := output.get("departmentObject")) is not None:
        kwargs["department_object"] = _deserialize_department_object(
            _department_object, config
        )

    if (_manager_object := output.get("managerObject")) is not None:
        kwargs["manager_object"] = _deserialize_manager_object(_manager_object, config)

    return ManagerObject(**kwargs)


def _deserialize_okta_user_discovery_list(
    output: DocumentValue, config: Config
) -> list[OktaUserDiscoveryListMember]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_okta_user_discovery_list_member(e, config) for e in output]


def _deserialize_okta_user_discovery_list_member(
    output: DocumentValue, config: Config
) -> OktaUserDiscoveryListMember:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "userId" not in output:
        raise ServiceError(
            'Expected to find "userId" in the operation output, but it was not present.'
        )
    kwargs["user_id"] = expect_type(str, output["userId"])

    if (_okta_username := output.get("oktaUsername")) is not None:
        kwargs["okta_username"] = expect_type(str, _okta_username)

    if (_first_name := output.get("firstName")) is not None:
        kwargs["first_name"] = expect_type(str, _first_name)

    if (_last_name := output.get("lastName")) is not None:
        kwargs["last_name"] = expect_type(str, _last_name)

    if (_okta_connection_id := output.get("oktaConnectionId")) is not None:
        kwargs["okta_connection_id"] = expect_type(str, _okta_connection_id)

    if (_okta_email := output.get("oktaEmail")) is not None:
        kwargs["okta_email"] = expect_type(str, _okta_email)

    if (_created_at := output.get("createdAt")) is not None:
        kwargs["created_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _created_at)
        )

    if (_updated_at := output.get("updatedAt")) is not None:
        kwargs["updated_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _updated_at)
        )

    if (_added_to_register := output.get("addedToRegister")) is not None:
        kwargs["added_to_register"] = expect_type(bool, _added_to_register)

    if (_last_discovered_at := output.get("lastDiscoveredAt")) is not None:
        kwargs["last_discovered_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _last_discovered_at)
        )

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    return OktaUserDiscoveryListMember(**kwargs)


def _deserialize_open_properties(
    output: DocumentValue, config: Config
) -> dict[str, Document]:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found { type(output) }")

    return {k: Document(v) for k, v in output.items() if v is not None}


def _deserialize_owner_object(output: DocumentValue, config: Config) -> OwnerObject:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_id := output.get("id")) is not None:
        kwargs["id"] = expect_type(str, _id)

    if (_meta := output.get("meta")) is not None:
        kwargs["meta"] = Document(_meta)

    return OwnerObject(**kwargs)


def _deserialize_owner_object_list(
    output: DocumentValue, config: Config
) -> list[OwnerObject]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_owner_object(e, config) for e in output]


def _deserialize_postal_address(output: DocumentValue, config: Config) -> PostalAddress:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "street" not in output:
        raise ServiceError(
            'Expected to find "street" in the operation output, but it was not present.'
        )
    kwargs["street"] = expect_type(str, output["street"])

    if "city" not in output:
        raise ServiceError(
            'Expected to find "city" in the operation output, but it was not present.'
        )
    kwargs["city"] = expect_type(str, output["city"])

    if "country" not in output:
        raise ServiceError(
            'Expected to find "country" in the operation output, but it was not present.'
        )
    kwargs["country"] = expect_type(str, output["country"])

    if "zipcode" not in output:
        raise ServiceError(
            'Expected to find "zipcode" in the operation output, but it was not present.'
        )
    kwargs["zipcode"] = expect_type(str, output["zipcode"])

    return PostalAddress(**kwargs)


def _deserialize_processing_activitiy_data_source_collection(
    output: DocumentValue, config: Config
) -> list[str]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [expect_type(str, e) for e in output]


def _deserialize_processing_activity_asset_list(
    output: DocumentValue, config: Config
) -> list[AssetRecord]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_asset_record(e, config) for e in output]


def _deserialize_processing_activity_department(
    output: DocumentValue, config: Config
) -> ProcessingActivityDepartment:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "departmentId" not in output:
        raise ServiceError(
            'Expected to find "departmentId" in the operation output, but it was not present.'
        )
    kwargs["department_id"] = expect_type(str, output["departmentId"])

    if "name" not in output:
        raise ServiceError(
            'Expected to find "name" in the operation output, but it was not present.'
        )
    kwargs["name"] = expect_type(str, output["name"])

    return ProcessingActivityDepartment(**kwargs)


def _deserialize_processing_activity_department_list(
    output: DocumentValue, config: Config
) -> list[ProcessingActivityDepartment]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_processing_activity_department(e, config) for e in output]


def _deserialize_processing_activity_employee(
    output: DocumentValue, config: Config
) -> ProcessingActivityEmployee:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "employeeId" not in output:
        raise ServiceError(
            'Expected to find "employeeId" in the operation output, but it was not present.'
        )
    kwargs["employee_id"] = expect_type(str, output["employeeId"])

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_surname := output.get("surname")) is not None:
        kwargs["surname"] = expect_type(str, _surname)

    return ProcessingActivityEmployee(**kwargs)


def _deserialize_processing_activity_filter_output_list(
    output: DocumentValue, config: Config
) -> list[ListProcessingActivityFilterMember]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [
        _deserialize_list_processing_activity_filter_member(e, config) for e in output
    ]


def _deserialize_processing_activity_list(
    output: DocumentValue, config: Config
) -> list[ProcessingActivityListRecord]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_processing_activity_list_record(e, config) for e in output]


def _deserialize_processing_activity_list_record(
    output: DocumentValue, config: Config
) -> ProcessingActivityListRecord:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "processingActivityId" not in output:
        raise ServiceError(
            'Expected to find "processingActivityId" in the operation output, but it was not present.'
        )
    kwargs["processing_activity_id"] = expect_type(str, output["processingActivityId"])

    if (_active := output.get("active")) is not None:
        kwargs["active"] = expect_type(bool, _active)

    if (_department_objects := output.get("departmentObjects")) is not None:
        kwargs["department_objects"] = _deserialize_processing_activity_department_list(
            _department_objects, config
        )

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_recipient_objects := output.get("recipientObjects")) is not None:
        kwargs["recipient_objects"] = _deserialize_processing_activity_recipient_list(
            _recipient_objects, config
        )

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_created_by := output.get("createdBy")) is not None:
        kwargs["created_by"] = expect_type(str, _created_by)

    if (_updated_at := output.get("updatedAt")) is not None:
        kwargs["updated_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _updated_at)
        )

    return ProcessingActivityListRecord(**kwargs)


def _deserialize_processing_activity_of_recipient_list(
    output: DocumentValue, config: Config
) -> list[ProcessingActivityOfRecipientMember]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [
        _deserialize_processing_activity_of_recipient_member(e, config) for e in output
    ]


def _deserialize_processing_activity_of_recipient_member(
    output: DocumentValue, config: Config
) -> ProcessingActivityOfRecipientMember:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "processingActivityId" not in output:
        raise ServiceError(
            'Expected to find "processingActivityId" in the operation output, but it was not present.'
        )
    kwargs["processing_activity_id"] = expect_type(str, output["processingActivityId"])

    if "name" not in output:
        raise ServiceError(
            'Expected to find "name" in the operation output, but it was not present.'
        )
    kwargs["name"] = expect_type(str, output["name"])

    if "active" not in output:
        raise ServiceError(
            'Expected to find "active" in the operation output, but it was not present.'
        )
    kwargs["active"] = expect_type(bool, output["active"])

    if "updatedAt" not in output:
        raise ServiceError(
            'Expected to find "updatedAt" in the operation output, but it was not present.'
        )
    kwargs["updated_at"] = epoch_seconds_to_datetime(
        expect_type(int | float, output["updatedAt"])
    )

    if "createdBy" not in output:
        raise ServiceError(
            'Expected to find "createdBy" in the operation output, but it was not present.'
        )
    kwargs["created_by"] = expect_type(str, output["createdBy"])

    return ProcessingActivityOfRecipientMember(**kwargs)


def _deserialize_processing_activity_recipient_list(
    output: DocumentValue, config: Config
) -> list[ProcessingActivityRecipientMember]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [
        _deserialize_processing_activity_recipient_member(e, config) for e in output
    ]


def _deserialize_processing_activity_recipient_member(
    output: DocumentValue, config: Config
) -> ProcessingActivityRecipientMember:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_business_name := output.get("businessName")) is not None:
        kwargs["business_name"] = expect_type(str, _business_name)

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_categories := output.get("categories")) is not None:
        kwargs["categories"] = _deserialize_recipient_category_collection(
            _categories, config
        )

    if (_role := output.get("role")) is not None:
        kwargs["role"] = expect_type(str, _role)

    if (_country := output.get("country")) is not None:
        kwargs["country"] = expect_type(str, _country)

    if (_state := output.get("state")) is not None:
        kwargs["state"] = expect_type(str, _state)

    if (_dpa := output.get("dpa")) is not None:
        kwargs["dpa"] = expect_type(str, _dpa)

    if (_dpa_files := output.get("dpaFiles")) is not None:
        kwargs["dpa_files"] = _deserialize_uuid_collection(_dpa_files, config)

    if (_dpa_status := output.get("dpaStatus")) is not None:
        kwargs["dpa_status"] = expect_type(str, _dpa_status)

    if (_recipient_model_id := output.get("recipientModelId")) is not None:
        kwargs["recipient_model_id"] = expect_type(str, _recipient_model_id)

    if (_recipient_warranties := output.get("recipientWarranties")) is not None:
        kwargs["recipient_warranties"] = _deserialize_warranty_list(
            _recipient_warranties, config
        )

    if (_data_storage_location := output.get("dataStorageLocation")) is not None:
        kwargs["data_storage_location"] = _deserialize_country_list(
            _data_storage_location, config
        )

    if (_discovery_source := output.get("discoverySource")) is not None:
        kwargs["discovery_source"] = _deserialize_discovery_source_list(
            _discovery_source, config
        )

    if (_discovered_date := output.get("discoveredDate")) is not None:
        kwargs["discovered_date"] = epoch_seconds_to_datetime(
            expect_type(int | float, _discovered_date)
        )

    if (_recipient_id := output.get("recipientId")) is not None:
        kwargs["recipient_id"] = expect_type(str, _recipient_id)

    if (_comment := output.get("comment")) is not None:
        kwargs["comment"] = expect_type(str, _comment)

    return ProcessingActivityRecipientMember(**kwargs)


def _deserialize_recipient_category_collection(
    output: DocumentValue, config: Config
) -> list[str]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [expect_type(str, e) for e in output]


def _deserialize_recipient_filter_output_list(
    output: DocumentValue, config: Config
) -> list[RecipientFilterOutputListMember]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_recipient_filter_output_list_member(e, config) for e in output]


def _deserialize_recipient_filter_output_list_member(
    output: DocumentValue, config: Config
) -> RecipientFilterOutputListMember:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_id := output.get("id")) is not None:
        kwargs["id"] = expect_type(str, _id)

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    return RecipientFilterOutputListMember(**kwargs)


def _deserialize_recipient_for_filter_member(
    output: DocumentValue, config: Config
) -> RecipientForFilterMember:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "recipientId" not in output:
        raise ServiceError(
            'Expected to find "recipientId" in the operation output, but it was not present.'
        )
    kwargs["recipient_id"] = expect_type(str, output["recipientId"])

    if "name" not in output:
        raise ServiceError(
            'Expected to find "name" in the operation output, but it was not present.'
        )
    kwargs["name"] = expect_type(str, output["name"])

    return RecipientForFilterMember(**kwargs)


def _deserialize_recipient_list(
    output: DocumentValue, config: Config
) -> list[RecipientListMember]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_recipient_list_member(e, config) for e in output]


def _deserialize_recipient_list_member(
    output: DocumentValue, config: Config
) -> RecipientListMember:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_recipient_id := output.get("recipientId")) is not None:
        kwargs["recipient_id"] = expect_type(str, _recipient_id)

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_categories := output.get("categories")) is not None:
        kwargs["categories"] = _deserialize_recipient_category_collection(
            _categories, config
        )

    if (_role := output.get("role")) is not None:
        kwargs["role"] = expect_type(str, _role)

    if (_discovery_source := output.get("discoverySource")) is not None:
        kwargs["discovery_source"] = _deserialize_discovery_source_list(
            _discovery_source, config
        )

    if (_last_modification := output.get("lastModification")) is not None:
        kwargs["last_modification"] = epoch_seconds_to_datetime(
            expect_type(int | float, _last_modification)
        )

    if (_processing_activities := output.get("processingActivities")) is not None:
        kwargs["processing_activities"] = expect_type(int, _processing_activities)

    return RecipientListMember(**kwargs)


def _deserialize_recipients_discovered_of_domain_list(
    output: DocumentValue, config: Config
) -> list[str]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [expect_type(str, e) for e in output]


def _deserialize_recipients_for_filter_list(
    output: DocumentValue, config: Config
) -> list[RecipientForFilterMember]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_recipient_for_filter_member(e, config) for e in output]


def _deserialize_record_type(output: DocumentValue, config: Config) -> dict[str, str]:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found { type(output) }")

    return {k: expect_type(str, v) for k, v in output.items() if v is not None}


def _deserialize_resource_inventory_list(
    output: DocumentValue, config: Config
) -> list[ResourceInventoryListMember]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_resource_inventory_list_member(e, config) for e in output]


def _deserialize_resource_inventory_list_member(
    output: DocumentValue, config: Config
) -> ResourceInventoryListMember:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "resourceId" not in output:
        raise ServiceError(
            'Expected to find "resourceId" in the operation output, but it was not present.'
        )
    kwargs["resource_id"] = expect_type(str, output["resourceId"])

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_type := output.get("type")) is not None:
        kwargs["type"] = expect_type(str, _type)

    if (_meta := output.get("meta")) is not None:
        kwargs["meta"] = _deserialize_open_properties(_meta, config)

    if (_owner := output.get("owner")) is not None:
        kwargs["owner"] = _deserialize_owner_object_list(_owner, config)

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_source := output.get("source")) is not None:
        kwargs["source"] = expect_type(str, _source)

    if (_parent_id := output.get("parentId")) is not None:
        kwargs["parent_id"] = expect_type(str, _parent_id)

    if (_failed_rules := output.get("failedRules")) is not None:
        kwargs["failed_rules"] = _deserialize_unique_string_list(_failed_rules, config)

    if (_data_classification := output.get("dataClassification")) is not None:
        kwargs["data_classification"] = _deserialize_unique_string_list(
            _data_classification, config
        )

    if (_data_categories := output.get("dataCategories")) is not None:
        kwargs["data_categories"] = _deserialize_unique_string_list(
            _data_categories, config
        )

    if (_scan := output.get("scan")) is not None:
        kwargs["scan"] = _deserialize_scan_information(_scan, config)

    if (_first_seen := output.get("firstSeen")) is not None:
        kwargs["first_seen"] = expect_type(str, _first_seen)

    if (_last_updated := output.get("lastUpdated")) is not None:
        kwargs["last_updated"] = expect_type(str, _last_updated)

    if (_severity_score := output.get("severityScore")) is not None:
        kwargs["severity_score"] = expect_type(int, _severity_score)

    if (_properties := output.get("properties")) is not None:
        kwargs["properties"] = _deserialize_open_properties(_properties, config)

    if (_aka := output.get("aka")) is not None:
        kwargs["aka"] = expect_type(str, _aka)

    if (_issue_id := output.get("issueId")) is not None:
        kwargs["issue_id"] = expect_type(str, _issue_id)

    return ResourceInventoryListMember(**kwargs)


def _deserialize_resource_stats(
    output: DocumentValue, config: Config
) -> dict[str, ResourceStatsData]:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found { type(output) }")

    return {
        k: _deserialize_resource_stats_data(v, config)
        for k, v in output.items()
        if v is not None
    }


def _deserialize_resource_stats_data(
    output: DocumentValue, config: Config
) -> ResourceStatsData:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_full_scan_inspected_bytes := output.get("fullScanInspectedBytes")) is not None:
        kwargs["full_scan_inspected_bytes"] = expect_type(
            int, _full_scan_inspected_bytes
        )

    if (
        _sample_scan_inspected_bytes := output.get("sampleScanInspectedBytes")
    ) is not None:
        kwargs["sample_scan_inspected_bytes"] = expect_type(
            int, _sample_scan_inspected_bytes
        )

    if (_infotypes_count := output.get("infotypesCount")) is not None:
        kwargs["infotypes_count"] = expect_type(int, _infotypes_count)

    if (_infotype_tokens_count := output.get("infotypeTokensCount")) is not None:
        kwargs["infotype_tokens_count"] = expect_type(int, _infotype_tokens_count)

    if (_scanned_resources := output.get("scannedResources")) is not None:
        kwargs["scanned_resources"] = expect_type(int, _scanned_resources)

    if (_unscanned_resources := output.get("unscannedResources")) is not None:
        kwargs["unscanned_resources"] = expect_type(int, _unscanned_resources)

    return ResourceStatsData(**kwargs)


def _deserialize_retention_period(
    output: DocumentValue, config: Config
) -> RetentionPeriod:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_unit := output.get("unit")) is not None:
        kwargs["unit"] = expect_type(str, _unit)

    if (_value := output.get("value")) is not None:
        kwargs["value"] = expect_type(int, _value)

    return RetentionPeriod(**kwargs)


def _deserialize_sample_tokens(output: DocumentValue, config: Config) -> SampleTokens:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_token := output.get("token")) is not None:
        kwargs["token"] = expect_type(str, _token)

    if (_info_type := output.get("infoType")) is not None:
        kwargs["info_type"] = expect_type(str, _info_type)

    if (_column := output.get("column")) is not None:
        kwargs["column"] = expect_type(int, _column)

    if (_column_name := output.get("columnName")) is not None:
        kwargs["column_name"] = expect_type(str, _column_name)

    if (_row := output.get("row")) is not None:
        kwargs["row"] = expect_type(int, _row)

    return SampleTokens(**kwargs)


def _deserialize_sample_tokens_list(
    output: DocumentValue, config: Config
) -> list[SampleTokens]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_sample_tokens(e, config) for e in output]


def _deserialize_scan_data_processed(
    output: DocumentValue, config: Config
) -> ScanDataProcessed:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_read_from_source_bytes := output.get("readFromSourceBytes")) is not None:
        kwargs["read_from_source_bytes"] = expect_type(int, _read_from_source_bytes)

    if (_inspected_bytes := output.get("inspectedBytes")) is not None:
        kwargs["inspected_bytes"] = expect_type(int, _inspected_bytes)

    if (_extracted_bytes := output.get("extractedBytes")) is not None:
        kwargs["extracted_bytes"] = expect_type(int, _extracted_bytes)

    return ScanDataProcessed(**kwargs)


def _deserialize_scan_filter(output: DocumentValue, config: Config) -> ScanFilter:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_type := output.get("type")) is not None:
        kwargs["type"] = expect_type(str, _type)

    if (_filters := output.get("filters")) is not None:
        kwargs["filters"] = _deserialize_unique_string_list(_filters, config)

    return ScanFilter(**kwargs)


def _deserialize_scan_filter_list(
    output: DocumentValue, config: Config
) -> list[ScanFilter]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_scan_filter(e, config) for e in output]


def _deserialize_scan_information(
    output: DocumentValue, config: Config
) -> ScanInformation:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_type := output.get("type")) is not None:
        kwargs["type"] = expect_type(str, _type)

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_last_scan := output.get("lastScan")) is not None:
        kwargs["last_scan"] = epoch_seconds_to_datetime(
            expect_type(int | float, _last_scan)
        )

    return ScanInformation(**kwargs)


def _deserialize_scan_limits(output: DocumentValue, config: Config) -> ScanLimits:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_sample_percentage := output.get("samplePercentage")) is not None:
        kwargs["sample_percentage"] = limited_parse_float(_sample_percentage)

    if (
        _max_cumulative_data_size_mb := output.get("maxCumulativeDataSizeMb")
    ) is not None:
        kwargs["max_cumulative_data_size_mb"] = expect_type(
            int, _max_cumulative_data_size_mb
        )

    if (_items_per_batch := output.get("itemsPerBatch")) is not None:
        kwargs["items_per_batch"] = expect_type(int, _items_per_batch)

    if (_sample_duration_minutes := output.get("sampleDurationMinutes")) is not None:
        kwargs["sample_duration_minutes"] = expect_type(int, _sample_duration_minutes)

    return ScanLimits(**kwargs)


def _deserialize_scan_meta(output: DocumentValue, config: Config) -> ScanMeta:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    return ScanMeta(**kwargs)


def _deserialize_scan_parameters(
    output: DocumentValue, config: Config
) -> ScanParameters:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_resources := output.get("resources")) is not None:
        kwargs["resources"] = _deserialize_scan_resources(_resources, config)

    if (_resource_type := output.get("resourceType")) is not None:
        kwargs["resource_type"] = expect_type(str, _resource_type)

    if (_scan_filter := output.get("scanFilter")) is not None:
        kwargs["scan_filter"] = _deserialize_scan_filter_list(_scan_filter, config)

    if (_inspection_policy := output.get("inspectionPolicy")) is not None:
        kwargs["inspection_policy"] = _deserialize_inspection_policy(
            _inspection_policy, config
        )

    return ScanParameters(**kwargs)


def _deserialize_scan_record(output: DocumentValue, config: Config) -> ScanRecord:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "scanId" not in output:
        raise ServiceError(
            'Expected to find "scanId" in the operation output, but it was not present.'
        )
    kwargs["scan_id"] = expect_type(str, output["scanId"])

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_scan_type := output.get("scanType")) is not None:
        kwargs["scan_type"] = expect_type(str, _scan_type)

    if (_resource_type := output.get("resourceType")) is not None:
        kwargs["resource_type"] = expect_type(str, _resource_type)

    if (_resources := output.get("resources")) is not None:
        kwargs["resources"] = _deserialize_scan_resources(_resources, config)

    if (_connector_id := output.get("connectorId")) is not None:
        kwargs["connector_id"] = expect_type(str, _connector_id)

    if (_connector_type := output.get("connectorType")) is not None:
        kwargs["connector_type"] = expect_type(str, _connector_type)

    if (_data_plane_id := output.get("dataPlaneId")) is not None:
        kwargs["data_plane_id"] = expect_type(str, _data_plane_id)

    if (_data_plane_name := output.get("dataPlaneName")) is not None:
        kwargs["data_plane_name"] = expect_type(str, _data_plane_name)

    if (_data_plane_slug := output.get("dataPlaneSlug")) is not None:
        kwargs["data_plane_slug"] = expect_type(str, _data_plane_slug)

    if (_schedule_type := output.get("scheduleType")) is not None:
        kwargs["schedule_type"] = expect_type(str, _schedule_type)

    if (_cron := output.get("cron")) is not None:
        kwargs["cron"] = expect_type(str, _cron)

    if (_scan_filter := output.get("scanFilter")) is not None:
        kwargs["scan_filter"] = _deserialize_scan_filter_list(_scan_filter, config)

    if (_scan_limits := output.get("scanLimits")) is not None:
        kwargs["scan_limits"] = _deserialize_scan_limits(_scan_limits, config)

    if (_inspection_policy := output.get("inspectionPolicy")) is not None:
        kwargs["inspection_policy"] = _deserialize_inspection_policy(
            _inspection_policy, config
        )

    if (_snapshot := output.get("snapshot")) is not None:
        kwargs["snapshot"] = _deserialize_inspection_result_snapshot(_snapshot, config)

    if (_meta := output.get("meta")) is not None:
        kwargs["meta"] = _deserialize_scan_meta(_meta, config)

    if (_stats := output.get("stats")) is not None:
        kwargs["stats"] = _deserialize_scan_stats(_stats, config)

    if (_elapsed_time_ms := output.get("elapsedTimeMs")) is not None:
        kwargs["elapsed_time_ms"] = expect_type(int, _elapsed_time_ms)

    if (_created_at := output.get("createdAt")) is not None:
        kwargs["created_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _created_at)
        )

    if (_updated_at := output.get("updatedAt")) is not None:
        kwargs["updated_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _updated_at)
        )

    if (_schedule := output.get("schedule")) is not None:
        kwargs["schedule"] = _deserialize_scan_schedule(_schedule, config)

    if (_next_execution := output.get("nextExecution")) is not None:
        kwargs["next_execution"] = epoch_seconds_to_datetime(
            expect_type(int | float, _next_execution)
        )

    return ScanRecord(**kwargs)


def _deserialize_scan_resources(output: DocumentValue, config: Config) -> ScanResources:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_account_id := output.get("accountId")) is not None:
        kwargs["account_id"] = expect_type(str, _account_id)

    if (_region := output.get("region")) is not None:
        kwargs["region"] = expect_type(str, _region)

    if (_search := output.get("search")) is not None:
        kwargs["search"] = expect_type(str, _search)

    if (_resource_type := output.get("resourceType")) is not None:
        kwargs["resource_type"] = expect_type(str, _resource_type)

    if (_resource_ids := output.get("resourceIds")) is not None:
        kwargs["resource_ids"] = _deserialize_unique_string_list(_resource_ids, config)

    if (_parent_id := output.get("parentId")) is not None:
        kwargs["parent_id"] = expect_type(str, _parent_id)

    if (_is_public := output.get("isPublic")) is not None:
        kwargs["is_public"] = expect_type(bool, _is_public)

    if (_is_unencrypted := output.get("isUnencrypted")) is not None:
        kwargs["is_unencrypted"] = expect_type(bool, _is_unencrypted)

    if (_tags := output.get("tags")) is not None:
        kwargs["tags"] = _deserialize_tag_filter_list(_tags, config)

    if (_database := output.get("database")) is not None:
        kwargs["database"] = _deserialize_unique_string_list(_database, config)

    if (_dataset := output.get("dataset")) is not None:
        kwargs["dataset"] = _deserialize_unique_string_list(_dataset, config)

    if (_schema := output.get("schema")) is not None:
        kwargs["schema"] = _deserialize_unique_string_list(_schema, config)

    if (_drive_id := output.get("driveId")) is not None:
        kwargs["drive_id"] = _deserialize_unique_string_list(_drive_id, config)

    if (_zendesk_group_id := output.get("zendeskGroupId")) is not None:
        kwargs["zendesk_group_id"] = _deserialize_unique_long_list(
            _zendesk_group_id, config
        )

    if (_google_groups := output.get("googleGroups")) is not None:
        kwargs["google_groups"] = _deserialize_unique_string_list(
            _google_groups, config
        )

    if (_org_unit_id := output.get("orgUnitId")) is not None:
        kwargs["org_unit_id"] = _deserialize_unique_string_list(_org_unit_id, config)

    if (_drive_type := output.get("driveType")) is not None:
        kwargs["drive_type"] = _deserialize_unique_string_list(_drive_type, config)

    if (_info_types := output.get("infoTypes")) is not None:
        kwargs["info_types"] = _deserialize_info_types_combination_filter(
            _info_types, config
        )

    if (_is_archived := output.get("isArchived")) is not None:
        kwargs["is_archived"] = expect_type(bool, _is_archived)

    if (_is_external := output.get("isExternal")) is not None:
        kwargs["is_external"] = expect_type(bool, _is_external)

    if (_team_id := output.get("teamId")) is not None:
        kwargs["team_id"] = expect_type(str, _team_id)

    if (_team_name := output.get("teamName")) is not None:
        kwargs["team_name"] = expect_type(str, _team_name)

    if (_team_url := output.get("teamUrl")) is not None:
        kwargs["team_url"] = expect_type(str, _team_url)

    if (_is_private := output.get("isPrivate")) is not None:
        kwargs["is_private"] = expect_type(bool, _is_private)

    if (_is_slack_direct_messages := output.get("isSlackDirectMessages")) is not None:
        kwargs["is_slack_direct_messages"] = expect_type(
            bool, _is_slack_direct_messages
        )

    if (_space_status := output.get("spaceStatus")) is not None:
        kwargs["space_status"] = _deserialize_unique_string_list(_space_status, config)

    if (_space_type := output.get("spaceType")) is not None:
        kwargs["space_type"] = _deserialize_unique_string_list(_space_type, config)

    if (_all := output.get("all")) is not None:
        kwargs["all"] = expect_type(bool, _all)

    return ScanResources(**kwargs)


def _deserialize_scan_schedule(output: DocumentValue, config: Config) -> ScanSchedule:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_calendars := output.get("calendars")) is not None:
        kwargs["calendars"] = _deserialize_calendar_spec_list(_calendars, config)

    if (_timezone := output.get("timezone")) is not None:
        kwargs["timezone"] = expect_type(str, _timezone)

    return ScanSchedule(**kwargs)


def _deserialize_scans_list(output: DocumentValue, config: Config) -> list[ScanRecord]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_scan_record(e, config) for e in output]


def _deserialize_scan_stats(output: DocumentValue, config: Config) -> ScanStats:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_state_change_events := output.get("stateChangeEvents")) is not None:
        kwargs["state_change_events"] = _deserialize_state_change_events_list(
            _state_change_events, config
        )

    if (_data_processed := output.get("dataProcessed")) is not None:
        kwargs["data_processed"] = _deserialize_scan_data_processed(
            _data_processed, config
        )

    return ScanStats(**kwargs)


def _deserialize_security_risk(output: DocumentValue, config: Config) -> SecurityRisk:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_failed_rules := output.get("failedRules")) is not None:
        kwargs["failed_rules"] = _deserialize_unique_string_list(_failed_rules, config)

    return SecurityRisk(**kwargs)


def _deserialize_state_change_events(
    output: DocumentValue, config: Config
) -> StateChangeEvents:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_previous_status := output.get("previousStatus")) is not None:
        kwargs["previous_status"] = expect_type(str, _previous_status)

    if (_epoch := output.get("epoch")) is not None:
        kwargs["epoch"] = expect_type(int, _epoch)

    return StateChangeEvents(**kwargs)


def _deserialize_state_change_events_list(
    output: DocumentValue, config: Config
) -> list[StateChangeEvents]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_state_change_events(e, config) for e in output]


def _deserialize_tag_filter(output: DocumentValue, config: Config) -> TagFilter:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "action" not in output:
        raise ServiceError(
            'Expected to find "action" in the operation output, but it was not present.'
        )
    kwargs["action"] = expect_type(str, output["action"])

    if "tagKey" not in output:
        raise ServiceError(
            'Expected to find "tagKey" in the operation output, but it was not present.'
        )
    kwargs["tag_key"] = expect_type(str, output["tagKey"])

    if (_tag_value := output.get("tagValue")) is not None:
        kwargs["tag_value"] = expect_type(str, _tag_value)

    return TagFilter(**kwargs)


def _deserialize_tag_filter_list(
    output: DocumentValue, config: Config
) -> list[TagFilter]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_tag_filter(e, config) for e in output]


def _deserialize_tagging_result(output: DocumentValue, config: Config) -> TaggingResult:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_resource_id := output.get("resourceId")) is not None:
        kwargs["resource_id"] = expect_type(str, _resource_id)

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    return TaggingResult(**kwargs)


def _deserialize_tagging_results_list(
    output: DocumentValue, config: Config
) -> list[TaggingResult]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_tagging_result(e, config) for e in output]


def _deserialize_tokens(
    output: DocumentValue, config: Config
) -> dict[str, list[SampleTokens]]:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found { type(output) }")

    return {
        k: _deserialize_sample_tokens_list(v, config)
        for k, v in output.items()
        if v is not None
    }


def _deserialize_tom_collection(
    output: DocumentValue, config: Config
) -> list[TomListMember]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_tom_list_member(e, config) for e in output]


def _deserialize_tom_list_member(
    output: DocumentValue, config: Config
) -> TomListMember:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_tom_id := output.get("tomId")) is not None:
        kwargs["tom_id"] = expect_type(str, _tom_id)

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_description := output.get("description")) is not None:
        kwargs["description"] = expect_type(str, _description)

    if (_list_ := output.get("list")) is not None:
        kwargs["list_"] = expect_type(str, _list_)

    if (_category := output.get("category")) is not None:
        kwargs["category"] = expect_type(str, _category)

    if (_type := output.get("type")) is not None:
        kwargs["type"] = expect_type(str, _type)

    if (_reference_code := output.get("referenceCode")) is not None:
        kwargs["reference_code"] = expect_type(str, _reference_code)

    if (_status := output.get("status")) is not None:
        kwargs["status"] = expect_type(str, _status)

    if (_note := output.get("note")) is not None:
        kwargs["note"] = expect_type(str, _note)

    return TomListMember(**kwargs)


def _deserialize_unique_long_list(output: DocumentValue, config: Config) -> list[int]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [expect_type(int, e) for e in output]


def _deserialize_unique_string_list(output: DocumentValue, config: Config) -> list[str]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [expect_type(str, e) for e in output]


def _deserialize_url_list(
    output: DocumentValue, config: Config
) -> list[ExportedDataUrl]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_exported_data_url(e, config) for e in output]


def _deserialize_user_profile_list(
    output: DocumentValue, config: Config
) -> list[UserProfileRecord]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_user_profile_record(e, config) for e in output]


def _deserialize_user_profile_record(
    output: DocumentValue, config: Config
) -> UserProfileRecord:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if (_name := output.get("name")) is not None:
        kwargs["name"] = expect_type(str, _name)

    if (_connector_id := output.get("connectorId")) is not None:
        kwargs["connector_id"] = expect_type(str, _connector_id)

    if (_email := output.get("email")) is not None:
        kwargs["email"] = expect_type(str, _email)

    if (_connector_user_id := output.get("connectorUserId")) is not None:
        kwargs["connector_user_id"] = expect_type(str, _connector_user_id)

    if (_connector_source_type := output.get("connectorSourceType")) is not None:
        kwargs["connector_source_type"] = expect_type(str, _connector_source_type)

    if (_connector_username := output.get("connectorUsername")) is not None:
        kwargs["connector_username"] = expect_type(str, _connector_username)

    if (_external := output.get("external")) is not None:
        kwargs["external"] = expect_type(bool, _external)

    if (_deleted_at := output.get("deletedAt")) is not None:
        kwargs["deleted_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _deleted_at)
        )

    if (_created_at := output.get("createdAt")) is not None:
        kwargs["created_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _created_at)
        )

    if (_updated_at := output.get("updatedAt")) is not None:
        kwargs["updated_at"] = epoch_seconds_to_datetime(
            expect_type(int | float, _updated_at)
        )

    if "userId" not in output:
        raise ServiceError(
            'Expected to find "userId" in the operation output, but it was not present.'
        )
    kwargs["user_id"] = expect_type(str, output["userId"])

    return UserProfileRecord(**kwargs)


def _deserialize_uuid_collection(output: DocumentValue, config: Config) -> list[str]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [expect_type(str, e) for e in output]


def _deserialize_warranty_list(output: DocumentValue, config: Config) -> list[str]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [expect_type(str, e) for e in output]


def _deserialize_validation_exception_field(
    output: DocumentValue, config: Config
) -> ValidationExceptionField:
    if not isinstance(output, dict):
        raise ServiceError(f"Expected dict, found {type(output)}")

    kwargs: dict[str, Any] = {}

    if "path" not in output:
        raise ServiceError(
            'Expected to find "path" in the operation output, but it was not present.'
        )
    kwargs["path"] = expect_type(str, output["path"])

    if "message" not in output:
        raise ServiceError(
            'Expected to find "message" in the operation output, but it was not present.'
        )
    kwargs["message"] = expect_type(str, output["message"])

    return ValidationExceptionField(**kwargs)


def _deserialize_validation_exception_field_list(
    output: DocumentValue, config: Config
) -> list[ValidationExceptionField]:
    if not isinstance(output, list):
        raise ServiceError(f"Expected list, found {type(output)}")
    return [_deserialize_validation_exception_field(e, config) for e in output]
